GNU bug report logs - #13011
24.2; Text flickering moving cursor with box around text enabled

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: mario giovinazzo <mario.giovinazzo@HIDDEN>; merged with #13130, #17612; dated Tue, 27 Nov 2012 16:34:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 19 Jan 2018 18:15:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 19 13:15:57 2018
Received: from localhost ([127.0.0.1]:35215 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ecbCm-0000Hq-Hb
	for submit <at> debbugs.gnu.org; Fri, 19 Jan 2018 13:15:57 -0500
Received: from mail-lf0-f52.google.com ([209.85.215.52]:40839)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alexandre.adolphe@HIDDEN>) id 1ecb5R-00006j-1F
 for 13011 <at> debbugs.gnu.org; Fri, 19 Jan 2018 13:08:22 -0500
Received: by mail-lf0-f52.google.com with SMTP id h92so3111530lfi.7
 for <13011 <at> debbugs.gnu.org>; Fri, 19 Jan 2018 10:08:21 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=tRpiFogv0qqVLCB9Hs6IlVezenwyV6BuxXi2eVZvOvY=;
 b=DRTOhyJEwZdYztdjZ9sXzPu8FSbPRSnhW3zJV4zz3VcZwMr4JHOQOK7fEfad/wSy4d
 xC6ENOyJuK23XQ1MTwXHhIMWBjMbjWSjLdx3GLrsedFbYyV8YHBN1YOC0Qneq3J7QGq7
 E31Gf3Fn6Lx2DHL8QGbMMD1KxJSuyzOhgrMkcewgs9vyO+4UOtYIGqiuhJTGCpkj61VF
 reT8TI4dhwWHY3QJcV3IYC85RkWiFyEkr9hVx14D98MJ5lSF2osE5zpdauiQoCu1cIPl
 WjNC/l/KC11MVQ4qT/n/RcRWOjR/QCC9DTrRHbLYvaNdXtI+LbWa/QH8kG3cSzGEncCF
 U3gA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=tRpiFogv0qqVLCB9Hs6IlVezenwyV6BuxXi2eVZvOvY=;
 b=e6JxuV8PWt1Ij+Vo3XLzeWgK9xeCGdfIgrJBM6jlr9GOfdYXji0Livqi3gq6jv4hp/
 DbpK7pQreOyDx6/JNmlTdtB+gk9t44WvmE+j9lrX0NILIhf7Zd7Y8iFCKTAlB6lj5Bny
 WNPtlf+1XFUqEIg+FcjIDxBis3JfGK/WFaNK+ANj2EuvOy5iYssAe+emvJaZHeo2MDAV
 LCwG3McDqBPBJuvXGj7CGzodKpyZSofaVp/3tkZWMPGcaU0i1cTWAlja7nJBHApoJQ+9
 HNS43fGBULxMH466KWWnx55dXvEz+r8IdW0wqzNGe8WRuwxRAzeekallsKrmCNr/ramV
 g3MQ==
X-Gm-Message-State: AKwxytetXbDzDkvfIiO85GD786zdMDOkZs1MVFVxrUXoS8HbX277vT8G
 uhf22qB/SQGcJDWNFfBhlVIOUZ2g7kfhl0fYiGQ0cg==
X-Google-Smtp-Source: ACJfBosWBbbxTK2b+DMlrhmRALXOqlOGk5koO2iz+BO24o+mzxlTVM0Z7lxvdcXoeCWaTUYkxY/rsAhs6ZyyTgN7fBk=
X-Received: by 10.46.42.195 with SMTP id q186mr8459365ljq.57.1516385294611;
 Fri, 19 Jan 2018 10:08:14 -0800 (PST)
MIME-Version: 1.0
Received: by 10.25.59.151 with HTTP; Fri, 19 Jan 2018 10:08:13 -0800 (PST)
From: Alexandre Adolphe <alexandre.adolphe@HIDDEN>
Date: Fri, 19 Jan 2018 19:08:13 +0100
Message-ID: <CAK73JcAALevDNitKoLtaZDar6xe7=TFFHnAW0GwNHmFo92=AAA@HIDDEN>
Subject: Patch: Text flickering moving cursor with box around text enabled
To: 13011 <at> debbugs.gnu.org
Content-Type: multipart/mixed; boundary="f4030439eb68d471c0056324f6f9"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 13011
X-Mailman-Approved-At: Fri, 19 Jan 2018 13:15:55 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

--f4030439eb68d471c0056324f6f9
Content-Type: multipart/alternative; boundary="f4030439eb68d471bc056324f6f7"

--f4030439eb68d471bc056324f6f7
Content-Type: text/plain; charset="UTF-8"

Hi,

I run into this issue so I tried to fix it to go into the emacs core code.
I followed the suggestion made in the bug and set box attribute to be
in the form (width . height). I tested it on windows and gnu/linux system
and on a mac os virtual machine but I am not sure to have tested all the
possible drawing as there are plenty of them. I tested both text box
and image relief.
I would appreciate that other people (especially those who use CAIRO
and those under real os x machine) confirm that the result is correct.

My simple test script :
----
(defun test_box_around_text (s)
  (save-excursion
    (goto-char (point-min))
    (insert "ABCDE\nABCDE\nABCDE\n")
    (put-text-property 8 11 'font-lock-face `(:box (:line-width ,s :color
"red")))
    ;; (put-text-property 8 11 'font-lock-face `(:box (:line-width ,s
:color "white" :style released-button)))
    ))

(test_box_around_text 4)
(test_box_around_text -4)
(test_box_around_text '(4 . -4))
(test_box_around_text '(-4 . 4))
(test_box_around_text '(-4 . -4))
(test_box_around_text '(4 . 0))
(test_box_around_text '(0 . 4))
(test_box_around_text '(4 . 1))
(test_box_around_text '(1 . 4))
(test_box_around_text '(-4 . 1))
(test_box_around_text '(1 . -4))

(save-excursion
    (goto-char (point-min))
    (insert-image
     (create-image
      "splash.svg" nil nil :relief 12)))
----

Thanks in advance,
Alexandre

--f4030439eb68d471bc056324f6f7
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><div>Hi,<br></div><div><div><br></div><div>I run into this=
 issue so I tried to fix it to go into the emacs core code.</div><div>I fol=
lowed the suggestion made in the bug and set box attribute to be</div><div>=
in the form (width . height). I tested it on windows and gnu/linux system</=
div><div>and on a mac os virtual machine but I am not sure to have tested a=
ll the</div><div>possible drawing as there are plenty of them. I tested bot=
h text box</div><div>and image relief.</div><div>I would appreciate that ot=
her people (especially those who use CAIRO</div><div>and those under real o=
s x machine) confirm that the result is correct.</div><div><br></div><div>M=
y simple test script :</div><div>----</div><div>(defun test_box_around_text=
 (s)</div><div>=C2=A0 (save-excursion</div><div>=C2=A0 =C2=A0 (goto-char (p=
oint-min))</div><div>=C2=A0 =C2=A0 (insert &quot;ABCDE\nABCDE\nABCDE\n&quot=
;)</div><div>=C2=A0 =C2=A0 (put-text-property 8 11 &#39;font-lock-face `(:b=
ox (:line-width ,s :color &quot;red&quot;)))</div><div>=C2=A0 =C2=A0 ;; (pu=
t-text-property 8 11 &#39;font-lock-face `(:box (:line-width ,s :color &quo=
t;white&quot; :style released-button)))</div><div>=C2=A0 =C2=A0 ))</div><di=
v><br></div><div>(test_box_around_text 4)</div><div>(test_box_around_text -=
4)</div><div>(test_box_around_text &#39;(4 . -4))</div><div>(test_box_aroun=
d_text &#39;(-4 . 4))</div><div>(test_box_around_text &#39;(-4 . -4))</div>=
<div>(test_box_around_text &#39;(4 . 0))</div><div>(test_box_around_text &#=
39;(0 . 4))</div><div>(test_box_around_text &#39;(4 . 1))</div><div>(test_b=
ox_around_text &#39;(1 . 4))</div><div>(test_box_around_text &#39;(-4 . 1))=
</div><div>(test_box_around_text &#39;(1 . -4))</div><div><br></div><div>(s=
ave-excursion</div><div>=C2=A0 =C2=A0 (goto-char (point-min))</div><div>=C2=
=A0 =C2=A0 (insert-image</div><div>=C2=A0 =C2=A0 =C2=A0(create-image</div><=
div>=C2=A0 =C2=A0 =C2=A0 &quot;splash.svg&quot; nil nil :relief 12)))</div>=
<div>----</div><div><br></div><div>Thanks in advance,<br></div><div>Alexand=
re</div></div><div><br></div></div>

--f4030439eb68d471bc056324f6f7--

--f4030439eb68d471c0056324f6f9
Content-Type: text/x-patch; charset="US-ASCII"; 
	name="0001-Allow-negative-line-width-for-box-face-attribute.patch"
Content-Disposition: attachment; 
	filename="0001-Allow-negative-line-width-for-box-face-attribute.patch"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_jcm8crgq0
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--f4030439eb68d471c0056324f6f9--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.
Merged 13011 13130 17612. Request was from Eli Zaretskii <eliz@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Merged 13011 13130. Request was from Dmitry Gutov <dgutov@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 11 Dec 2012 14:02:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 11 09:02:04 2012
Received: from localhost ([127.0.0.1]:36654 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TiQPL-0007t2-JD
	for submit <at> debbugs.gnu.org; Tue, 11 Dec 2012 09:02:03 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:9442)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TiQPJ-0007sd-LP
	for 13011 <at> debbugs.gnu.org; Tue, 11 Dec 2012 09:02:01 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAG6Zu09soXOY/2dsb2JhbABEtBGBCIIVAQEEAVYjBQsLNBIUGA0kiBwFugmQRAOIQppxgViDBw
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="209591529"
Received: from 108-161-115-152.dsl.teksavvy.com (HELO pastel.home)
	([108.161.115.152])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	11 Dec 2012 09:01:20 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id B1206520E1; Tue, 11 Dec 2012 09:01:19 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Message-ID: <jwv38zcady3.fsf-monnier+emacs@HIDDEN>
References: <13b4ec68081.mario.giovinazzo@HIDDEN>
	<83ip8nv785.fsf@HIDDEN> <838v94ai5u.fsf@HIDDEN>
Date: Tue, 11 Dec 2012 09:01:19 -0500
In-Reply-To: <838v94ai5u.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 11 Dec
	2012 14:26:53 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.0 (/)

> For the rest of the bug I'm awaiting the decision wrt how to treat
> vertical box borders whose width is negative.

I think the suggestion to support a new box width specification of the
form (WIDTH . HEIGHT) is the best option.  So for backward
compatibility -N will mean (N . -N) and if someone wants "all inside, no
flicker" she can use (-N . -N).


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 11 Dec 2012 12:27:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 11 07:27:46 2012
Received: from localhost ([127.0.0.1]:36536 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TiOw5-0004oO-St
	for submit <at> debbugs.gnu.org; Tue, 11 Dec 2012 07:27:46 -0500
Received: from mtaout21.012.net.il ([80.179.55.169]:34649)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TiOw3-0004oG-EK
	for 13011 <at> debbugs.gnu.org; Tue, 11 Dec 2012 07:27:44 -0500
Received: from conversion-daemon.a-mtaout21.012.net.il by
	a-mtaout21.012.net.il (HyperSendmail v2007.08) id
	<0MEV00A008ZYVN00@HIDDEN> for
	13011 <at> debbugs.gnu.org; Tue, 11 Dec 2012 14:27:01 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout21.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MEV00AKS98YOX70@HIDDEN>;
	Tue, 11 Dec 2012 14:26:59 +0200 (IST)
Date: Tue, 11 Dec 2012 14:26:53 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <83ip8nv785.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: mario.giovinazzo@HIDDEN
Message-id: <838v94ai5u.fsf@HIDDEN>
References: <13b4ec68081.mario.giovinazzo@HIDDEN> <83ip8nv785.fsf@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview:  > Date: Fri,
	30 Nov 2012 10:13:30 +0200 > From: Eli Zaretskii
	<eliz@HIDDEN> > Cc: 13011 <at> debbugs.gnu.org > > > Date: Fri,
	30 Nov 2012 01:45:30
	+0100 (CET) > > From: "mario.giovinazzo@HIDDEN"
	<mario.giovinazzo@HIDDEN>
	> > Cc: <monnier@HIDDEN> > > > > The horizontal flickering
	has
	2 cases: > > > > 1) font-lock mode disabled. > > Current line has a
	single
	global box around current line > > Moving cursor vertically produce 1
	pixel
	flickering due to the left border > > that adds 1 pixel. > > Moving
	cursor
	horizontal (along the same line) produce flickering crossing > >
	parenthesis
	when paren-mode is enabled. 2 more pixels if the matching > > one is in
	another line,
	4 more pixels if on the same. This because it draw > > a box on
	highlight
	parenthesis adding 2 pixels for box. > > This is the same problem as
	with
	stretches of white space. Its reason > is separate from the one that
	causes
	the entire line to shift one > pixel to the right when the line
	thickness
	is -1. > > > 2) Font-lock-mode enabled. > > Current line seems to have
	a
	single global box but looking careful it has > > many consecutive boxes,
	one
	for every font-lock-face. > > Same as above: a different reason. [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.169 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.4794]
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.7 (/)

> Date: Fri, 30 Nov 2012 10:13:30 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 13011 <at> debbugs.gnu.org
> 
> > Date: Fri, 30 Nov 2012 01:45:30 +0100 (CET)
> > From: "mario.giovinazzo@HIDDEN" <mario.giovinazzo@HIDDEN>
> > Cc:  <monnier@HIDDEN>
> > 
> > The horizontal flickering has 2 cases:
> > 
> > 1) font-lock mode disabled.
> > Current line has a single global box around current line 
> > Moving cursor vertically produce 1 pixel flickering due to the left border 
> > that adds 1 pixel.
> > Moving cursor horizontal (along the same line) produce flickering crossing 
> > parenthesis when paren-mode is enabled. 2 more pixels if the matching 
> > one is in another line, 4 more pixels if on the same. This because it draw 
> > a box on highlight parenthesis adding  2 pixels for box.
> 
> This is the same problem as with stretches of white space.  Its reason
> is separate from the one that causes the entire line to shift one
> pixel to the right when the line thickness is -1.
> 
> > 2) Font-lock-mode enabled.
> > Current line seems to have a single global box but looking careful it has 
> > many consecutive boxes, one for every font-lock-face.
> 
> Same as above: a different reason.

This part of the bug is now fixed in revision 111191 on the trunk.

For the rest of the bug I'm awaiting the decision wrt how to treat
vertical box borders whose width is negative.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 4 Dec 2012 00:17:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 19:17:53 2012
Received: from localhost ([127.0.0.1]:52150 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfgCv-0006Sf-8S
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 19:17:53 -0500
Received: from fencepost.gnu.org ([208.118.235.10]:53930)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <handa@HIDDEN>) id 1TfgCs-0006SY-FQ
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 19:17:51 -0500
Received: from [150.29.149.7] (port=49319 helo=mongkok)
	by fencepost.gnu.org with esmtpsa (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
	(Exim 4.71) (envelope-from <handa@HIDDEN>)
	id 1TfgAW-0001O4-9z; Mon, 03 Dec 2012 19:15:24 -0500
From: Kenichi Handa <handa@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-Reply-To: <83ip8jrt7p.fsf@HIDDEN> (message from Eli Zaretskii on Mon,
	03 Dec 2012 18:33:30 +0200)
Date: Tue, 04 Dec 2012 09:13:44 +0900
Message-ID: <871uf63c93.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: 13011
Cc: monnier@HIDDEN, mario.giovinazzo@HIDDEN,
	13011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -5.0 (-----)

In article <83ip8jrt7p.fsf@HIDDEN>, Eli Zaretskii <eliz@HIDDEN> writes:

> So does anyone object to lifting this limitation, even though it might
> degrade the quality of displaying the first and the last characters in
> the run of characters that have the box face?

I don't object to add a feature of drawing box edges inside
the left and right of characters, but I think it is better
to keep the current asymmetric feature too.

How about allowing (VWIDTH . HWIDTH) as a value of :line-width?

---
Kenichi Handa
handa@HIDDEN




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 22:53:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 17:53:45 2012
Received: from localhost ([127.0.0.1]:52086 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfetV-0003ec-GB
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 17:53:45 -0500
Received: from aserp1040.oracle.com ([141.146.126.69]:34361)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1TfetS-0003eS-Ku
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 17:53:44 -0500
Received: from acsinet21.oracle.com (acsinet21.oracle.com [141.146.126.237])
	by aserp1040.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id qB3MpGZO023913
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Mon, 3 Dec 2012 22:51:17 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by acsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	qB3MpFvH006885
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Mon, 3 Dec 2012 22:51:15 GMT
Received: from abhmt117.oracle.com (abhmt117.oracle.com [141.146.116.69])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	qB3MpFqQ020993; Mon, 3 Dec 2012 16:51:15 -0600
Received: from dradamslap1 (/130.35.178.8)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 03 Dec 2012 14:51:14 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Stefan Monnier'" <monnier@HIDDEN>,
	"'Eli Zaretskii'" <eliz@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN>
	<83ip8jrt7p.fsf@HIDDEN><562186ED35E84B3086ABFBDAB2F056FD@HIDDEN><83624jrot8.fsf@HIDDEN><08681D95624F4B7AAD11488179A56F59@HIDDEN><831uf7rmkt.fsf@HIDDEN><C711DAF198F54038BC91239B972E9DBA@HIDDEN><83wqwyrgnr.fsf@HIDDEN>
	<jwvzk1uvkyc.fsf-monnier+emacs@HIDDEN>
Subject: RE: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Date: Mon, 3 Dec 2012 14:51:13 -0800
Message-ID: <448932616F30460694E17490B4955497@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <jwvzk1uvkyc.fsf-monnier+emacs@HIDDEN>
Thread-Index: Ac3RpHh+yO6SDP6MTNGkUGS8n/9umAAAyXkg
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: acsinet21.oracle.com [141.146.126.237]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.5 (-)

> I'd first like to hear why Drew uses negative thickness (and yet
> wants it to be positive horizontally).

IIRC, I use negative thickness mainly so the height is not increased.  I
typically do not care so much about the width (length) of a boxed word.  But I
do not want added border pixels to change the line height etc.

It really doesn't matter why or when or whether I use negative thickness.  The
question is which of these is the case:

1. The box left & right borders should be allowed to bump into the text that is
boxed.

2. Instead, the box should be shifted to the right because we have added extra
pixel(s) for the box border to the left of the text.

3. We should let users decide between #1 and #2.  For example, using a new box
attribute.

It's really not about me.  It's somewhat about how users use this today, and
what they expect.  But it's also about how users might use it (whether they do
or do not today) and what a user might expect from it.

> Also that's a hack, I can totally imagine someone using a very
> high-resolution screen with largish fonts (measured in pixels) wanting
> a -3 thickness around his hl-line box.

Me too.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 22:23:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 17:23:54 2012
Received: from localhost ([127.0.0.1]:52065 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfeQc-0002yZ-65
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 17:23:54 -0500
Received: from userp1040.oracle.com ([156.151.31.81]:26889)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1TfeQZ-0002yP-BV
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 17:23:52 -0500
Received: from acsinet22.oracle.com (acsinet22.oracle.com [141.146.126.238])
	by userp1040.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id qB3MLPEn026955
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Mon, 3 Dec 2012 22:21:26 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by acsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	qB3MLOA7013052
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Mon, 3 Dec 2012 22:21:24 GMT
Received: from abhmt102.oracle.com (abhmt102.oracle.com [141.146.116.54])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	qB3MLOge032136; Mon, 3 Dec 2012 16:21:24 -0600
Received: from dradamslap1 (/130.35.178.8)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 03 Dec 2012 14:21:24 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Eli Zaretskii'" <eliz@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
	<562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
	<83624jrot8.fsf@HIDDEN>
	<08681D95624F4B7AAD11488179A56F59@HIDDEN>
	<831uf7rmkt.fsf@HIDDEN>
	<C711DAF198F54038BC91239B972E9DBA@HIDDEN>
	<83wqwyrgnr.fsf@HIDDEN>
Subject: RE: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Date: Mon, 3 Dec 2012 14:21:22 -0800
Message-ID: <1C7A5D5E5BD847599E944D61E07853B5@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <83wqwyrgnr.fsf@HIDDEN>
Thread-Index: Ac3RmdNerB8DL5AiTi2FYMAXpsO0CwACUyPA
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: acsinet22.oracle.com [141.146.126.238]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13011
Cc: handa@HIDDEN, 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.5 (-)

> > > How about doing that only for 1-pixel borders?
> > 
> > Doing what?  Making the change or making the change only 
> > for whitespace?
> 
> The former.
> 
> > Either way, I don't see why the width would make a 
> > difference.  What is the rationale?
> 
> 1 pixel runs a very small risk of obscuring the character in the same
> cell.

I see.  Would probably need to see the effect to judge it.

> > > when a box face is used for
> > > hl-line mode, moving cursor vertically produces an 
> > > annoying shift of the lines as the cursor moves through them.
> > 
> > Try it with a positive width - same thing.
> 
> Yes, but the above says negative values should not have that effect.

Hm.  Is the problem the annoyance of the jerkiness or the fact that the doc does
not describe that jerkiness in the case of a negative value?

I would expect (imagine) that it is the jerkiness that is the problem.

> > > > Would it be possible for this to be a user choice?
> > > 
> > > It's possible.
> > 
> > That I would be in favor of.  Simply changing the 
> > behavior/appearance without user choice, I would be against.
> > Again, just one opinion, of course.
> 
> What about using thickness of zero for drawing a 1-pixel border inside
> of the character cell?

If the problem is only for a 1-pixel inside border, then perhaps that would be
the answer.  If the problem is for any number of pixels or for both inside and
outside borders (or both), then it would be appropriate to add a separate
attribute, independent from the width.

As far as I am concerned, if the only change is to add a new 0-width behavior
that produces a 1-pixel inside border that partially obscures the text, I would
have no problem with that.  In that case, IIUC, the existing attributes and
their values all would do the same thing they do now.  Currently, AFAICT, a
value of 0 means no box is shown.

On the other hand, any (existing or future) code that increments/decrements the
width would then be confronted with an anomaly, and if it expected a value of 0
to remove the box in that context, that would no longer work.

A new, independent attribute would be cleaner, but perhaps it is more difficult
to implement.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 22:23:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 17:23:19 2012
Received: from localhost ([127.0.0.1]:52062 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfeQ1-0002xh-PI
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 17:23:18 -0500
Received: from chene.dit.umontreal.ca ([132.204.246.20]:42297)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TfePz-0002xZ-A2
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 17:23:16 -0500
Received: from faina.iro.umontreal.ca (lechon.iro.umontreal.ca
	[132.204.27.242])
	by chene.dit.umontreal.ca (8.14.1/8.14.1) with ESMTP id qB3MKm5P021109; 
	Mon, 3 Dec 2012 17:20:48 -0500
Received: by faina.iro.umontreal.ca (Postfix, from userid 20848)
	id 64B7DB415D; Mon,  3 Dec 2012 17:20:48 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Message-ID: <jwvzk1uvkyc.fsf-monnier+emacs@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
	<562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
	<83624jrot8.fsf@HIDDEN>
	<08681D95624F4B7AAD11488179A56F59@HIDDEN>
	<831uf7rmkt.fsf@HIDDEN>
	<C711DAF198F54038BC91239B972E9DBA@HIDDEN>
	<83wqwyrgnr.fsf@HIDDEN>
Date: Mon, 03 Dec 2012 17:20:48 -0500
In-Reply-To: <83wqwyrgnr.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 03 Dec
	2012 23:04:40 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-NAI-Spam-Flag: NO
X-NAI-Spam-Threshold: 5
X-NAI-Spam-Score: 0
X-NAI-Spam-Rules: 1 Rules triggered
	RV4421=0
X-NAI-Spam-Version: 2.2.0.9309 : core <4421> : streams <870618> : uri <1284450>
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: 13011
Cc: mario.giovinazzo@HIDDEN, 13011 <at> debbugs.gnu.org,
	Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.5 (---)

>> That I would be in favor of.  Simply changing the behavior/appearance
>> without user choice, I would be against.  Again, just one opinion,
>> of course.
> What about using thickness of zero for drawing a 1-pixel border inside
> of the character cell?

I'd first like to hear why Drew uses negative thickness (and yet
wants it to be positive horizontally).

Also that's a hack, I can totally imagine someone using a very
high-resolution screen with largish fonts (measured in pixels) wanting
a -3 thickness around his hl-line box.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 21:07:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 16:07:13 2012
Received: from localhost ([127.0.0.1]:52000 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfdEO-0001Bs-KS
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 16:07:12 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:45367)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TfdEL-0001Bk-T5
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 16:07:11 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
	a-mtaout23.012.net.il (HyperSendmail v2007.08) id
	<0MEH00K003I40U00@HIDDEN> for
	13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 23:04:44 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout23.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MEH00J8D3VVSS30@HIDDEN>;
	Mon, 03 Dec 2012 23:04:44 +0200 (IST)
Date: Mon, 03 Dec 2012 23:04:40 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <C711DAF198F54038BC91239B972E9DBA@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Drew Adams <drew.adams@HIDDEN>
Message-id: <83wqwyrgnr.fsf@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
	<562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
	<83624jrot8.fsf@HIDDEN>
	<08681D95624F4B7AAD11488179A56F59@HIDDEN>
	<831uf7rmkt.fsf@HIDDEN>
	<C711DAF198F54038BC91239B972E9DBA@HIDDEN>
X-Spam-Score: 0.7 (/)
X-Debbugs-Envelope-To: 13011
Cc: handa@HIDDEN, 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.2 (/)

> From: "Drew Adams" <drew.adams@HIDDEN>
> Cc: <handa@HIDDEN>, <mario.giovinazzo@HIDDEN>, <13011 <at> debbugs.gnu.org>
> Date: Mon, 3 Dec 2012 11:09:13 -0800
> 
> > > I guess I would not object to making such a change for 
> > > situations where the chars to be partly obscured are
> > > whitespace only.  But I do object to overwriting
> > > typical chars such as those with word or symbol syntax.
> > 
> > How about doing that only for 1-pixel borders?
> 
> Doing what?  Making the change or making the change only for whitespace?

The former.

> Either way, I don't see why the width would make a difference.  What is the
> rationale?

1 pixel runs a very small risk of obscuring the character in the same
cell.

> > > Is the proposed change only a "fix" for negative values or does it
> > > affect also positive values?
> > 
> > Only negative values will be affected.
> 
> Why?  The same jerkiness from alignment change occurs for both positive and
> negative, AFAICT.

Yes, that's true.  But negative thickness does not enlarge the
vertical dimensions of character cells, whereas it does enlarge the
horizontal dimensions.  The request is to remove this asymmetry, as
the ELisp manual seems to promise:

    `(:line-width WIDTH :color COLOR :style STYLE)'
          This way you can explicitly specify all aspects of the box.
          The value WIDTH specifies the width of the lines to draw; it
          defaults to 1.  A negative width -N means to draw a line of
          width N that occupies the space of the underlying text, thus
          avoiding any increase in the character height or width.

But in fact, character width _is_ increased.

> > > What is the motivation for this change?
> > 
> > See the beginning of this bug report: when a box face is used for
> > hl-line mode, moving cursor vertically produces an annoying shift of
> > the lines as the cursor moves through them.
> 
> Try it with a positive width - same thing.

Yes, but the above says negative values should not have that effect.

> > > Would it be possible for this to be a user choice?
> > 
> > It's possible.
> 
> That I would be in favor of.  Simply changing the behavior/appearance without
> user choice, I would be against.  Again, just one opinion, of course.

What about using thickness of zero for drawing a 1-pixel border inside
of the character cell?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 19:11:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 14:11:45 2012
Received: from localhost ([127.0.0.1]:51885 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfbQe-0006vc-K3
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 14:11:45 -0500
Received: from aserp1040.oracle.com ([141.146.126.69]:18524)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1TfbQb-0006vT-Sf
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 14:11:43 -0500
Received: from ucsinet22.oracle.com (ucsinet22.oracle.com [156.151.31.94])
	by aserp1040.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id qB3J9GX9027706
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Mon, 3 Dec 2012 19:09:17 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by ucsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	qB3J9FWw000547
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Mon, 3 Dec 2012 19:09:15 GMT
Received: from abhmt104.oracle.com (abhmt104.oracle.com [141.146.116.56])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	qB3J9E5c022097; Mon, 3 Dec 2012 13:09:15 -0600
Received: from dradamslap1 (/130.35.178.8)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 03 Dec 2012 11:09:14 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Eli Zaretskii'" <eliz@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
	<562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
	<83624jrot8.fsf@HIDDEN>
	<08681D95624F4B7AAD11488179A56F59@HIDDEN>
	<831uf7rmkt.fsf@HIDDEN>
Subject: RE: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Date: Mon, 3 Dec 2012 11:09:13 -0800
Message-ID: <C711DAF198F54038BC91239B972E9DBA@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <831uf7rmkt.fsf@HIDDEN>
Thread-Index: Ac3RiAVmbQiEw6+cSy+K1BF33BquXQAAO5Kw
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: ucsinet22.oracle.com [156.151.31.94]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13011
Cc: handa@HIDDEN, 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.5 (-)

> > I guess I would not object to making such a change for 
> > situations where the chars to be partly obscured are
> > whitespace only.  But I do object to overwriting
> > typical chars such as those with word or symbol syntax.
> 
> How about doing that only for 1-pixel borders?

Doing what?  Making the change or making the change only for whitespace?

Either way, I don't see why the width would make a difference.  What is the
rationale?

> Yes, that's it.
> 
> > Is the proposed change only a "fix" for negative values or does it
> > affect also positive values?
> 
> Only negative values will be affected.

Why?  The same jerkiness from alignment change occurs for both positive and
negative, AFAICT.

> > What is the motivation for this change?
> 
> See the beginning of this bug report: when a box face is used for
> hl-line mode, moving cursor vertically produces an annoying shift of
> the lines as the cursor moves through them.

Try it with a positive width - same thing.

Again, hl-line boxing is hardly typical, I think (again, not at all typical for
my use, at least).  More typical is boxing a word or two.

And one could even argue that that jerkiness was a feature (!) for hl-line mode.
Anyway, hl-line mode should not be important to this - boxing is for many more
use cases than that.

> > Would it be possible for this to be a user choice?
> 
> It's possible.

That I would be in favor of.  Simply changing the behavior/appearance without
user choice, I would be against.  Again, just one opinion, of course.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 18:59:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 13:59:44 2012
Received: from localhost ([127.0.0.1]:51864 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfbF1-0006dh-H0
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 13:59:43 -0500
Received: from mtaout21.012.net.il ([80.179.55.169]:61884)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TfbEx-0006dY-Qv
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 13:59:41 -0500
Received: from conversion-daemon.a-mtaout21.012.net.il by
	a-mtaout21.012.net.il (HyperSendmail v2007.08) id
	<0MEG00K00XRP8T00@HIDDEN> for
	13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 20:56:58 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout21.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MEG00KLSXYV4N30@HIDDEN>;
	Mon, 03 Dec 2012 20:56:55 +0200 (IST)
Date: Mon, 03 Dec 2012 20:56:50 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <08681D95624F4B7AAD11488179A56F59@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Drew Adams <drew.adams@HIDDEN>
Message-id: <831uf7rmkt.fsf@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
	<562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
	<83624jrot8.fsf@HIDDEN>
	<08681D95624F4B7AAD11488179A56F59@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: "Drew Adams" <drew.adams@HIDDEN> > Cc:
	<handa@HIDDEN>, 
	<mario.giovinazzo@HIDDEN>, <13011 <at> debbugs.gnu.org> > Date: Mon,
	3 Dec 2012 10:41:52 -0800 > > Apart from that example,
	I imagine that this also
	affects any text that uses a > face that has a box with a negative
	:line-width. Is that correct? [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.169 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.4999]
X-Debbugs-Envelope-To: 13011
Cc: handa@HIDDEN, 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: "Drew Adams" <drew.adams@HIDDEN> > Cc: <handa@HIDDEN>,
    <mario.giovinazzo@HIDDEN>, <13011 <at> debbugs.gnu.org> > Date: Mon, 3 Dec
    2012 10:41:52 -0800 > > Apart from that example, I imagine that this also
    affects any text that uses a > face that has a box with a negative :line-width.
    Is that correct? [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.169 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.4605]

> From: "Drew Adams" <drew.adams@HIDDEN>
> Cc: <handa@HIDDEN>, <mario.giovinazzo@HIDDEN>, <13011 <at> debbugs.gnu.org>
> Date: Mon, 3 Dec 2012 10:41:52 -0800
> 
> Apart from that example, I imagine that this also affects any text that uses a
> face that has a box with a negative :line-width.  Is that correct?

Yes.

> If so, that will impact faces that I use.  And IIUC, it means that the text
> displayed in the boxed face will have its first and last chars partly obscured
> by the box border.  Is that right?

Right.

> I guess I would not object to making such a change for situations where the
> chars to be partly obscured are whitespace only.  But I do object to overwriting
> typical chars such as those with word or symbol syntax.

How about doing that only for 1-pixel borders?

> Attached is a screenshot from emacs -Q.  IIUC, you are saying that instead of
> the text shown in mode-line-highlight face being slightly misaligned wrt the
> other text, so that the `a' is not partly obscured by the left box border, the
> text would be aligned with the others and the boxed `a' would be partly obscured
> by the left box border.

Yes, that's it.

> Is the proposed change only a "fix" for negative values or does it
> affect also positive values?

Only negative values will be affected.

> What is the motivation for this change?

See the beginning of this bug report: when a box face is used for
hl-line mode, moving cursor vertically produces an annoying shift of
the lines as the cursor moves through them.

> Would it be possible for this to be a user choice?

It's possible.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 18:44:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 13:44:25 2012
Received: from localhost ([127.0.0.1]:51813 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tfb0D-0006HQ-F9
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 13:44:25 -0500
Received: from userp1040.oracle.com ([156.151.31.81]:47040)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1Tfb0A-0006HI-Qe
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 13:44:23 -0500
Received: from ucsinet21.oracle.com (ucsinet21.oracle.com [156.151.31.93])
	by userp1040.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id qB3IfteQ021673
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Mon, 3 Dec 2012 18:41:56 GMT
Received: from acsmt356.oracle.com (acsmt356.oracle.com [141.146.40.156])
	by ucsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	qB3Ifsmh014368
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Mon, 3 Dec 2012 18:41:55 GMT
Received: from abhmt110.oracle.com (abhmt110.oracle.com [141.146.116.62])
	by acsmt356.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	qB3Ifs5s002970; Mon, 3 Dec 2012 12:41:54 -0600
Received: from dradamslap1 (/130.35.178.8)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 03 Dec 2012 10:41:53 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Eli Zaretskii'" <eliz@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
	<562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
	<83624jrot8.fsf@HIDDEN>
Subject: RE: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Date: Mon, 3 Dec 2012 10:41:52 -0800
Message-ID: <08681D95624F4B7AAD11488179A56F59@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed;
	boundary="----=_NextPart_000_0071_01CDD142.CF16B130"
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <83624jrot8.fsf@HIDDEN>
Thread-Index: Ac3RgTvt3DbljrNERwC4O7HInivC6QAAJ8PA
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: ucsinet21.oracle.com [156.151.31.93]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13011
Cc: handa@HIDDEN, 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.5 (-)

This is a multi-part message in MIME format.

------=_NextPart_000_0071_01CDD142.CF16B130
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit

Thanks for the explanation and experiment.

Apart from that example, I imagine that this also affects any text that uses a
face that has a box with a negative :line-width.  Is that correct?

If so, that will impact faces that I use.  And IIUC, it means that the text
displayed in the boxed face will have its first and last chars partly obscured
by the box border.  Is that right?

If so, I would object.  Most uses of such faces are not like the hl-line
example, where there is a lot of text so faced.  Most uses (most of mine, at
least) are short bits of text, such as words.  And for these uses it is more
important that the first and last chars be displayed clearly (entirely).  I even
use a boxed face for some single characters (including using it for face
`escape-glyph').

I guess I would not object to making such a change for situations where the
chars to be partly obscured are whitespace only.  But I do object to overwriting
typical chars such as those with word or symbol syntax.

At least I think I object.  This change seems like regression, not improvement.

Attached is a screenshot from emacs -Q.  IIUC, you are saying that instead of
the text shown in mode-line-highlight face being slightly misaligned wrt the
other text, so that the `a' is not partly obscured by the left box border, the
text would be aligned with the others and the boxed `a' would be partly obscured
by the left box border.

OK, so by default the boxing here is 2, not -2, but if you set it to -2 that
does not change the argument/situation, AFAICT.  Likewise, if I use 2 or 4 in
your example test I see the same effect of the text moving slightly to the right
as it is highlighted.  Is the proposed change only a "fix" for negative values
or does it affect also positive values?

What is the motivation for this change?  Is it only in order to have fixed-width
text be better aligned? To me, that is less important than for the text to be
clearly visible - esp. for single words etc.

The boxing is supposed to make the text stand out, not make it harder to read.
This change seems to go against the usefulness of boxed faces.

Would it be possible for this to be a user choice?  E.g., could this perhaps be
added to `box' as another attribute, in addition to width, color, and style?  If
so, that would perhaps be a solution everyone could live with.  If so, I would
suggest that the default be the current behavior (clear text, even if slightly
misaligned).

Just one opinion, of course.

------=_NextPart_000_0071_01CDD142.CF16B130
Content-Type: image/png;
	name="throw-boxed-face.png"
Content-Transfer-Encoding: base64
Content-Disposition: attachment;
	filename="throw-boxed-face.png"

iVBORw0KGgoAAAANSUhEUgAAAkoAAACuCAIAAABGC7VzAAAgAElEQVR4nOxdTWzbSJZ+2smiJQyU
tQ7ygG30NpVDo0ESWbUBBxj40GXnMocFmpNBKZdgTI1vcmZ7BosFFjACksj2HhaYDYTuaE6xLExf
RvR2osMc1yIPORlQxwuL6JkBRjSCmECUBpV1sOECxmoPxZ+iRMk/6R6nM/yQA131+N6r98pmfXys
1IX0B19d/OHsf/edp/fyEIdsNhvbHmD7bmdjjvtcTE8XmyS/fbdzaye9+gn3s7kTKgj13NrxrpfX
5m8vHNOeIMF3CFqpU9LSyh4n82e42ymlehrPDPeYkxnyrnFzvonjxbqqKSjuFAGt1FF5bk8e+zvQ
tQXBlYeF4D5V6CjdmKEREwDAK3F6Eny7cEqpnjcRqJkTJMVHJHHh5OGZPeyoHNfkbEGwu6F8rjks
4Bg9oRVV6CjdSA/gwrCZi3TxTJNzTJmTzV6q5ACZq0Bd48hMJkq+d4G5+dY73//f/3H/6aPvxw76
rbfemh6VwhXm2vsXpstMkS9cYVI7fVjIf3Dx5DoAnti3trO/+/S9VZFZFZnluePav+PYWO85V3OF
83YjwZ8NPGZSW33AeTR7hrszWEmbtSNcOWZtCl37+q+zT5++pyiMojB48qN0FuVxyjHy+UkyPGYq
KO7vwGy2ouTom1AlfmizKK8oDE45W5CLV/XaQxV6/UruLAuS80cGK4yCYcvI3uWcLc7LDsl7v3K5
22QUhVH4F0s3XaWSBfJsg8Kwe0lRGNx/LCgujxmMshXeVYEh7Qo/EIQBr+QQmT/ovaftdxRiaAsq
lSx488GtPOWaCuN1GRcqOKOVOjXEEXncf7xUA1TJI5Qj/jQxAJ9TeFcFpqtkAIDHDJk/nhWc+atj
B31L6iyum7ekzqJkbuzYN8jFEwCA3gNzUeosSp0bD6jH8hP7htRZXDdvSJ1FqbMo9bb9nnh5ggPb
l48oJzxs+27kru27ncV1u/fEJtoW1+3p7bDT81roRoCNdU+t71jo6jg21juLkrnxIFDl+TldD+mi
Gp1J8Zyo/4l9Q+rce+Lc8ocQcNMEbwi0XirVIf8ENfqrYdqC12Wq1ApXK3nyKcFWBb+rGwhHl7GU
/pRgR5QIdrdrj3Z1KaNqL+JV6E8vsNBVzVjnVaEzcVzRG2ltUTilVCclmCXijEasm2rXd1Iwx/2J
mvbaVSEczlg8nVIYN2LRDpQIquv7GZoI9QumQOLWtYVUR+nSqsIxkmuSNRKKIIOC6oYJEmxPc8mJ
JFqwg6SUtCChZAieRdoc8Z8K72jqJ6G75XAyg3FG24rJlwcuTcargsexAICXueEwjtnjwp7yUo1k
3ykJNvDM3tirha5qCqoLPLPXzEHXVk0mIPG8zA2Hp36TcTx7+9H1v7F+8wzW5j+/8uLm3cOffHL5
Hy/2Nw6y196/kHs/vyoyy+C0IRcSsovZawvQfuAuf3L5s58yy2D/+1dZ0hsvD/Dl9uN7/3n0k08u
f/ZTZnXh6Ffrz2bE3Pz7+WVwvryYX56DwhVmdc794tDTU7jCrC5A+/c+S7vqLVEntDu31t2fbXL/
Qvjc4eO//80R6frgKrM65/7qN4+/OMw//PS91bnBxkFuEuH74CqT2nl8bydzm6jy/SxM1rOx3tle
4H73z++siszq3OBGzV29ml8W07HxvL32Trz+i9lrIpPaca996g/hTaGkCTzwwPOXmk1GUZj+zf+q
5T0WZdQeK7Wjtb3L7buMgo9uCs/ySo4fWzWXNECVPJp1Sj/oIyKspDWhp81mlUoWwCkJrjL0lsa4
//gHN4/I6pvH3mrdY28e1aP04KObpf6s/6qwb/RvKi7xB6fsm0aWcKxJrAtVGEIKFd6t9bN0l1Hr
A85zZr+mZ5tDrknRu77Rp/RksJI2155Bc76LXyyVDtf2Ln8221fNbAXnKhi2VBeP+aMKHQ17q36F
HwjXXaWSRRUmtfVY0TJNEoownk4p1YPmfLfpx81/aYYqjMK7a2uPa/388Ol7Cj9QzRzmoauaKu+x
EF5/XOtnlUoWZrMVJcJCSBJp1svjMBQ89njGnpwOWMiwnUcfwlY//zR4bGCGNx3+s0uIz1YwbNWO
kJxHeXer9gI1L99FAJDBvLvFX2pXvFykttzK3js8QN/oe6wLw1btaK196dg3Ab+++QLdzfE86Ddf
BNS/b/Rvrj1WVVtVbVXLNLsMDwDGs1pqAsk2B6qZVnCG/DTbf7GmX1Bwpm/0VcVW1YHpzcwQRq23
tmbX9KNZlPd0Gs9qs/lY/VF/XL70Ni1Gz5/j2RsAwBxzewHg7XRhgTlphcyXLMxlTiK+vObX3uaY
2+LL9jdIUHYG2xBSnxsPXHji0iytIHIPP2EAABYKtxcAKOHFMQK6vFZYhng/R/U8sbffLoQlyYXC
7bcdj5BNjucU/QneWHRd1V/LjxQhcNNfsfLMb5WXmgYAjmYy0VUzJ/MA2sBULvnL21xzj/EutYFG
sRNBcaHrTqBKvjxmKKORGljgD8+d6Pd6MlxF6AhabkjV5CaCZ5oYgEvzgWOhQ8yoP11b4wph6Q4X
mpwTEDXc9M0F8dQGGi74tCPX9AMbGlc4rxDli/EywymmT9FyzRMUOOOHJTOcYnvkUn2pyDniGDYH
GiGIgg3gaGYuSMfeXk4TOinBwXsUVcIFrHl6QOtpmMGefq6JSe3TwScp4mo9hZvBAAA5zNn0CwDc
nB8O54fD+WETStEXCacbssJNyHiuOZzfU2ILruHsDUgt5c9ovmicpPb2f+3to+WrWTh88cVXF65d
yQy+6tP0a+RHAAgkAQAOBgHrmiT/5baTWw5rb4Ov+oS0BRcxeg5ffLED166OlRbG2w8GG8A8/NdL
pBq3KjKrIlXEGnMPILMcSkbkJ/kZr4cOAgAA9Hb6g/fzH1x0J8Vziv4vtwczSe3tzQTNuhi6vmXU
nNlKWKDqG30jn8e8q8UW1cxBhCH1X9RIbcMchIUQ7x9VHArEKD0jS+9Are9AnLlR1jXVNwCjZudR
ztSPeGW0UjWmxx9v/0XNuFDBmVDAb4mYoBuJca3fR3k0OyGeEBkvgLtFB2TMcwDwylQeMfXYoT+u
QX6s9jY5bhkuZdf6eWz2lvr59prnQ1+3Te5CdyujcM4W/LXRT4fDMZ6taS7AUR5FCqUoPxBUUHBG
vT7AzXzYc/JnG4Cm9jRtQFiRZoIJXlgi/vM5nOprkMecW1PdSmxxNzqFulu2MTtbQRf8xGXHZy+J
G0I0XXNrGlRwJog2bzq8/Ldo9hTz8GTs7VuHe6/mvxd+Yt96kFnyP3fsPXFJ4427zhl1LxRWD3rf
UL2K8hOgvRP6GYM5ZvnADupzAE77IHcc952i/6VFVO30ptcIE3wHkeHI72rXvh75usxVrof1sOtK
BmMgK2uqlOWUSN0FzwRUAAA01f96DRcUs1eaxteiwDNYG/jiTql01t+7Y5Dm5cKwCaWJVbezgmew
adN1tZD90PEE2NIyGI+Ml4rbZITFTgKO5hwvTdKl9ehanWm6AABdW4jGk5cZUO2QugEAAMaZrjow
cQ7jjKY6HPa6uqqZKkFzOD8cFqAULWfigmLaqhpSN89c+GxzSsfU3hzNZDxKNJwfDucVcxCXGkdV
gOcAeEaOnYcx8hk57jtYVZia+tE8ngWpYzcG/NvP/7gNAHPMwwrcWLd7C4XP5+wbD9yCyBQe2NG/
s7nbm4XlJ/aNdbsHAAuFh1cGi3cdACiI3Ofiy1ujf5dztzcLcLdzaye9vADbOyRS1CaBQBWkV8XM
vQdOQeQ+F9Mb6517Tyg1C4WHazkAmNQO4ERN525vFpZHG4/fRbCxbvbeDvwkg0qPKaf0hP4H7b5w
TDy55Z0/xekHAICd3qL3gCfOJ3hzQH0zncYYNM3FzXmsdUqa9yPpoj/Ipr+lDj/W13rB2xvAOaw5
fhnJiT5FvG+1Rz/I9r/GpvVgnDN5Zk9OB07SH2TzCrcnvxx7RHn6Q2g9gfpMINgYwKneH8TJemY0
0sgzw9+CINhdXNjjbUFxeZwDzekSt/GA8icN3ci36UF8VMHsckE8qe0HI3Ez082YoNF66LhFBxuq
otpDf9KKklEUh9750FVNoctEXrKFjyWnlLL5PU7mYXL805RpoJ0Z/VB+ykYR2kPPLhk7PQN9NZTR
mHnYHdkY4LXHbAyImYfR7SIjqnBh2MxNicP4xoDjH2/H7nv7y8HGugmVU+/Pe330J0hwWnRV8zpc
esVdaN+IkleHKpjw22Nf0zklwT1zOe08EV1DJICTsLfk8UYQUsM5xvuE5DulP0GCk4PeTnuSveFx
iN8mfF44yYjoTcrn7vDJccKN+X+BOP7x9qOf//HP7FOCk+Dh5vx5u5AgQYIEry8S9pYgQYIECd5A
JI+3BAnOEwcHB+ftQoIEbyZS6Q9+f/GH+eTxliDBueDg4OAPf/jDeXuRIMEbiNdk31uCBAkSJEjw
TSJ5vCVIkCBBgjcQ3/bLSeeW1Ns+65fuvQcmOSUgssHZx2nPmUuQ4DXElJeTurqk6qxUr6+wZ1Ds
3d2ur5xM1LtGcltG8WJWo1zetKYI6OpSg41z12qUy9YKdV+jvLRpxQyNmACAMw87wSuAmgjUzAmS
4iOSnPAeVqojvfFuXWZHbvCmzJie0EqjvDTSE0zEsIuVZFbfX6mvWJ5JJLdloK5RZCYDwPcuMD9/
xfPepiKzLKYt8l8snh6TThggOO05cwkSvIY4PDz8+uuvY7tYJKWMFiCxOHMGxSyS2P3WcyQWjxG0
GmqreP/+HUmSJElC7ETBmaKIUsbujDhJhkVSvK8zRTGquCjGD22mKEqShFKGcdZhnzsaZXUwMUKv
OVhEor9b/JjVDdbLAMn784/u1xVJkiSJ3f1ldV8Si0CebSC364okSeh5tbxpsUhCxaLI7jdSK6Rd
Yo1y2WAlVCTzp3jn/p1fSH6aRbEI3nzYDyxI/jzT1aVWsU7k0fPqLx9AURSLRUT8kZE3zRuplbrE
+gOQAiuvdN4bxJxnBgD+kW/jh5NNOHfttDjtOXPflN0ECb4t6OqSj3LDinRZjXJcT3hHudEo+12h
cGQZS+tfKjcizeVNy9oc7aKNNtSI7f2gK7QQiI84H3ozPq6p/o66Xi6rRIdObig3LP/mcnncn6hp
r51Ik+GMeRQGSNWJxUagpNywfD9DE6H+crlM4mY1yktLmxatKhwjudbV0HAgV25Y9A8jpryecgNo
J4JWShNtjvhv0QlYiqR+EixDZ1dW0IesbsTkywP7LrHUgJDLsyv1djuO2SO5LlmNSPZ1tdwAdqU+
9mrBIlOZXanLCKxGw5ICnsiu1Nvt01H649nblPPe4s4zywI4t/6hP08ObxPT7fXe9sWs1z7h3LXp
GD9h4JTnzJ3RboIEfwZ47I0FllUURZIk6Xn1x60Zj+zstqqbrYFI1q/oebXs9YysmlUdiqJYnNHV
HweLXdYoq/pMURKLALpa3vfX0hJ6Xv1x9TlZfbPIW+t67M2jepQe9LyqPpjx30YNdlvVTYv4g1KN
6m6RrPAnsa6iKHlg91vPi3TXbqsFSGT3W61HRbldVyh6N9htUXpYJLH71RbI7Tra/aX6SKzf/zjX
auwXRYRElDIaFhrzp1Fe0pEXCIk1yuq+JBaLopQyqps6S9ENEk86nKxRDl/qFkVJYver1WprILbv
35FYo2EhxILVKDdYj4Wwu9XWoCiJRRIFmoWQIdGsl0VhKFjk8Yz6ChuwkPYdsVgMuEkwfqPwsVxk
iyJKGcTYzL7RelSU739M0sjuGwX5jujlImXsf1T/mAUY7LY81oVSRmsg3pGPpcSt6u7f/QKxLOxW
dwPqP9htVavVBoHByoQrPWq1UhNItmU09tkgpTOD3erujITYwW6rsdloNAzLm5khdltqtdpoPRrM
FEVP56NWK/dRrP6oP9bIa4Ng/rzCeW+TzjPbGfTES75Y7vYnjHeMy8Rz16adr3ZqjJ8zd9x5bwkS
nD+s/YBUjBQhkOyvWNkVWbIMHQB0w5Kiq+b6CkuaZX95i7y/QQCgGzpN9jYtsCx9ijO6oaMVyigb
6w/7LguvBGuzvFTWUeyKfxSsJCMAlmUDx0KHVkb9sRo6K4frfCTLrB6QBySHgfPiqRt62BpeUcbr
XiHK72RXVtjNsk/RkHyCAmf8sFZW2M2GDgAAjYYlrXjakWXohCCWGwC6YaEgHfU60stLS2Ud1anA
IRnpnh7QVR0RRR4LAqtRLuvoJNVMXd1kP0QAAOhDdpOmw0hue5BBjafiJxuyVJ+QcSS32/XoZAvd
GqXitD9xygDgZLW3Cee9zbnx55kdTjiYbeK5axPPVyOIOU9uUnvsOXPTz3tLkOBccXh4+PXX/0Gx
Lomub+22jBkxXJgOdlu7MyJiLSO2qGYZEYY02G2R2oZlhIUQaazEFohRekaW3oFa34E4c6Osa6pv
ALutxkwRWY8G7Fi9b0yPP17ffChAOxSYiHgZ6YmPJ/w/e+fvI7eR5fFH4AI7WEMKpg2dcHDPBcaC
xUA+QA60BqZm9g+4wa6KCmxgpFPGnuAODgxYFlgF3QUOjMPBajrSj8FeIlbDloMLrW4GTlawvXdo
FrzB2SN4ZQHDhaRdH2AFBvqC4o/ir55uzcjTM3ofGLCarHr16lVJrMci+S31F+BeZAak5jkAZLs8
583sMOtXVN+dbI9bt2ttffp4nW6Lf/nLP/77ejcrv3Wve2w7Wt7ojiI4/oe/vFKY/MOn/xFtAzw+
dqoUuFPHogtbcJ52t0S04q8XZ2a/tgGMtkQ0irKkCLatNCwl/7uUWp9GsE679z7durfeuLlbnkLb
0dZ/H1tfP3UsG7hT9dmr43bqlDE8cE83k0e7ey9a3vjn6gi3z8M9vBjQpmd2+pgplHPndqYIs5+6
a/NwUO0iyBxkucf2liilb9s3RbEfli2t6Ur3prF+Hgm9qKUreSoAAKOtzBD1z2+Ltq2tBugKHUVZ
8dE8Neei290wHn3bT8MbtLTXY2Q/ZjwBolF3hVb6a8StnWKzM23xFePH9j19KhuW0tHtrQvl7nY3
NmBrq0jdAACArnS3t6JtukJXuqOtUZpQ6b00AX5jDkX989tbW1tF6pZWKK5tI7HL3tso2j4/NEhv
FtSKbd2EbjfLYevzsKF8t5Z0AwBUY1GhOo5zs/uLAe16b/Z/nn5U0zMDAFOcDOD08bW7j7J3Axp1
19qo6qi16bTtpjNXl2RDyTRkUdAvBhjPTHcphdFom/rDlWhVjNKf+pT5QLb5LHXxsH7pGX9KR6Ns
G6nyyHRao/pAdm7IKE4p3e5u3Njo5k6aD2R3z98ontRuMJQxEhfubeTe5y8GvLKV1my3sxJlLQ19
0K8m3OhuXbi5XYSmVOrGjY1u5SH03JutCxe2u3k8jYBW4rbd9RuCZtox41bubFHJOF740z1/vnvz
ZumFj9p7E+ZlqXjboj3+XaNpMJ2pdmDKiyKmh2m76cgYMzA3c6M8lOVA1N4A0McbXgxomIflV0Iq
dag/9OmUOFT6ix/lQpCDZPE/yrW9dUGAP9O9rWdsZO9sXbgwgxcjceHeU2+nHSTlNQSClzcEOUgW
9vJmvk47y7vhTTS/JnxQzNIj8yXlA3d4dmZ8Mf95Y/fL21HVe0O9NGQRWNjLG4IcdjB7Q5CD5O23
3z5oFxDkaIKXNwRBEOQIgooBCIIgyBEEL28IgiDIEQQvbwiCIMgR5Flf3h5d3sNH+puVATLu9JuP
75E7/ZIkwpwVG3QS2o7vF1PjsKf4IwdGLBzLsizLlU9VXbqz107LWrvUSIs5Im4/33yyfCbtWVPR
rNNP3e2DJxbO4XUeGka5GJOM0siZQyZdy5XV8lkw6nayk6X5V20jP+kIqUNbadGwVGvCEaj3VmX5
9RPW3QROL7320jzV7j+4fOcX//Xhq/qzlmsndzu+rw63x2FP8UcOjA71OFFCAuOMzF+dsFlrS9cR
JJzEIeec8ynFCePMGgSKeB7tNJ/ns5zpUK/NTod6nO+l2wdPFPQOr/MAQGxrEC1RiP68oocnm4jZ
HGFW4IqEebQDIF1rNejw8c6wzzkIRyjC+v2+UZwo13UHFvMoqdgphjmdq/mJfHYkwnm5t5QeXonO
uTIhjPc8Ly0esnROJr3x0Ouk08cw5lHUe2vh+7wLaWd1o7o7OiHLW7/T//JXlx58e/9BpYm2423+
6GC+dftJ1sFdlBNas9u2+CMLSWn9Wk1r8jWpeaKyUK0tdqtGzBbyc7Fw9LI3P1tbajtC1PLAQS2N
a8u6yuvyhnxNF5iW7aSmXVdngPqntqQr61V91bwRH328yIbzU2azRtyK/CU7WGQJ5dDlpJak2xTO
zJ7rmi4ZBkpVqtEqRiKvb9Y2rDoiNu00WW3NvI1ACA7M9xlw0TwqKi5C4ErCx2NfX8qZz+vXdBZO
QhZzpzTEsXAsR6iGxl1zVKTgMQtDpn8R/1aD/d1AvbcGvrrz3bXPfvqt7sLpnz649Odj68f/4ZdL
a/Doq5eW1k7C8usnLp58kgsjLL9+4uJpGP4xy9Iy4y3HW/157dcnLp588sHvvvv4h6XPP3z14snH
178/PiXha8lu2+KPLCiE8QxzcaykkFJGdLgz7HNORqurwmIe7cTCcTiki2ZOlJCjJcoZka7lKn14
JVpbDRIgjDMSm4tg006HeryycCYAEAvH4bY+tBSsCqX/kQKAJAoCKZf4JA5NP1uzrqJf5XwtiYJA
Ec9bikS28jZQ0rDToR5RQkrCJzxZXf2IDne8pNeLCGeMMWsQKAXkVjz0qkkFTftERqurriL9fp8T
JaRSCbkVD/ucWWJ1NbCYRzuluG1uRiqh4WTodQjTnZJSKhZOYt8KXLnEGYnFmqt6Ov7MGgRRh3m0
A1n5cjizrJeG46y8Ih73uZl4EJb+2Bmmyc9OP3EtR9LhkOnfIfc4swbBCKjHYBCMOny8E/aYToos
PgxZBwjTP8Y7faojqZ0hSkjF+sPebrm8cBW9ypmdDDZHS9lY6okohBBCSAWkd5XTThIFQcKucjMt
1xVKAwgE8nmR2glGCXTo1eGwn82V9IRUAIT1+33u0U48EEFCfa9uv+SPNmbeCTCbf5713qa1u9az
0y6cPHFl/cfhPuZAu+nPLa/bn//bCQCA08tXTu/iZ6P95vgjC0uxlnd4eYHNQnN1HMtBDPFAxoTf
Sg8DYwwIsSEWQuaHiT/Olr3xQNaW9bEctK7jtXmfpc1nZjLSU8S2IY4bVuCzo8S52J9k3ZsOY9oN
266Wjm3mk5I/UkrDbxaGDKTMcwLmZxG6peNZiZtf6a+2MQkZAPHH+jJPbBtirofMmbkPNYjvs2wk
pOBx6hpjDJSKpZQAUspYqbz7xB+HLOZ6dZO3ysKQxTrbKnUGWDiZhAyka7kyW6JMIxZCEnaWAJCz
jEhhJnssnGjq2dhcsHAybkzDpjpYvz+Q+dNsLON51ntrbferO4+OrxV7b4+/TnTSlv+hZL/SzQr1
49P15ypmnyI+MzqGLAilZMxMc8qrYOgkIxEklNMkKO1cEcY92slTouxwVnspCoIRLXbXOOfmVlil
EajaMc+bp2r1Go4UlI3qLFCOEiUVqVWo2sl+Q+X/BJIoyBf4Ra22+kRJIZe8PGVIfWJQ2gjsJCOz
upJCEh5WfNRpKVFCKlBSDCzWFK7G3pciQew0IVTCVW7Y10YIqF4QQUJ4nwxkpEbEyx2IByJIOiSJ
VYcVg0hsa7DZG1nWR1zSUo4WC+fl3miWaxtA/NGmGMWjIEuKkqTD6mNNGFFCKOJ1okCWvGgeQClc
qYg5Mj3P4zppdqQe/vREafM3m+6MgLkDGHPSOifrzaPeWyNPrgXZltj9B5dvv7h6Ov317f0n+uBb
ueLPz+HPXPZb4o8sJiqO85xCikr2ViyhpetKwn0G5CwjsbE1orcy4vLhWGR/ImcZAenm623pTt+F
Kdkx6u0zhI8nY06kO8uO0Fwwxgy/pevKPPsxOyQFjwk7S3R/z6VOzNTh1GmdQITMTGNtkl9a0nGp
VC0PMPF9JqWUMs2aciOxlEBsm4CUMSF23rDDY+aPx9UUivg+A8l5kXenHjg81te2fKO1vVeCx3mO
lqZpTRtwsVJAiJ1nkuZ+ZMOerysJH89wca3BGDOmv5mBz8ELr/2x4z18gf3vX1t4b+OLMxtfnHn3
+8mfvn9z44szVx9+80l8ZuOLNz/5MT2S/ffe77PI/P6b/OCZq9+8p6tPJpPJw/eM8mc2vvlsMoVK
4bx8y/HcmasPcwfe/OTHedv97OoXZzbi967GWeH42p+yc0V/42uffJPbv/Zu2Z+rD3XxtuMt/lT7
VcRzvvhMiT+yiBR/+RlP77WQ9J/J/AAY94eqt2QIH1cPE86Zca78z0tavvZvTt2OvsmX/ztesV3U
ME3lVgzGnGTHU9tVvxoTDMLDzJOs0er/q6XGtfgYt9VKd1tNP/ODZodL3Wos3dTfxjpFQNPxLMZS
lzevK0a4iriZQzsu/aiHuHGS1Ftp8LoUq1baJiIL641Ov4mY3j5tdbFUqxoI8855U9NAOH5zEkGQ
NtLHLp5yd6lkBma6Q/YMmc2JhXB1brLngQ6Z288a/GoJgiBlzJ384uGWuTGeZ1FPd4Nq38het5au
1X6PLj/5DG6ZPiuy9w54rN9hPBxe/1w8v3pvzxuob4cgyHMF3pxEEARBjiB4cxJBEAQ5guDlDUEQ
BDmC4OUNQRAEOYLg5Q1BEAQ5gqDe27PCVBjYFxa8v8h+gnpvhxPUe0O9t1k5EL23/eK4oTCwLyx4
f5H9BPXeDqdkGuq9od7bwuu9NZR/1BaH65e+/NV5df12XqWs9F2EotmfSkJWxPOSeitzdUoW21ge
OVyg3lsrqPeGem8AgHpv+6f31lh+aW39hcY4XOn9nXX3u2t3X7yiq2T6cMsAj79OPrj95LdVfwBO
wvLJv//X3omL6yce/+5/Pn4pVfH+9ra6fmnnFQEAACAASURBVPJVHc/lr7/7+IdUp60ti20rjxwu
UO/NjAbqvaHeG+q9tbB3vbcpemyNcQAAgLXe8lpextCHy3XjCn8A4P6T6/3U/jUj1VteP7GcJWqX
7x6/olXf2pm3PLKgoN7bLqDeW1oD9d5k2R/Ue5uz3dbyT5rj8Mu/mVMfzsxuT5T35wyXimx4Shym
lUcOB6j3Vi6Lem+o9wao9zYr87a7R304gOHdQh+uhRe7+np2/8FlYzvt+qXyvt3fvgBTmbc8soig
3hvqvaHeWx3Ue3sWem8t5R9OicO1d019uLRRfTYNS9mf/FQuLKdDV9aHy51s1XVrKY8cMlDvDfXe
UO+tyUXUe1sArl9S4Nn/tE8vACDIwoB6b4cD1HtrBL9asleuX/ry2v0n1y7t6VUHBFkgUO8N9d6O
BKj3dtRAXTcEQRBAvTcEQRDkSIKXNwQ5SN5///2DdgFBjia494YgCIIcQTB7Q5CDRGdv77zzzkE7
giBHDczeEARBkCMIXt4QBEGQIwhe3hAEQZAjCKp1Nzc65ZuTM7Y7xc6+9Gvf1cCRBWS3L0TOVHvm
opWvsjegX/ieUqD1jeiajrUh3dbQxF66jewBYyIYM6dBCTtuquOIWDhN0tnp0DeIdmetNMh5Z/PF
VO9L310vxPjKfy7PZFTrbmh0usr2jO1OsbMv/Zru5/VL3z76dUl4AVlMPv/8cwB44403Gs8Sxq1B
AA3fZZ8FwjhRQcI8ukvBWJz7iO7sDHeT7E61tqMlr61Mql/QWLNsmHrNXdPqccwaDJ622weOcNyk
NUILDmE6+hHt23JgpyOgxz3xdgrVwE3FPQr5V8y0lney6fCYMM4o9YgSwDNtbuk4knBG9fxJNQzT
YfY8Cul8UHkLPJtn0rUCmoobsmRzNQDqeZQy7U/IMm164DEnWQd0D4ao1t1Ck8p2a9ZVFE5lu4sC
jWrdc/VrXvv3H7x1/str9wvJOszwDgeldXM5cVHCaTpjrppF/u32ihJ0k31zYS5dy3J4HPPqKUOF
Tot2F22rBn3utqzLXJU3JmRt/lZdd5wGfe5Uv9tp1As3mk6PpymjcJs8MkXxisQ3b6xQ/K7bdxxH
xy0WjmXxWLrlhs2sN5MZj80mHRGbPypN5RLiYDpRCIsXRczmtP/VhGmGbD4eSNv3GbOn6AKCbeuW
hPGFTuLXP+ANAAAsHHNVEpAD6ToCiD8e+9XW9VTWmoWxEIrnn4Uj/ngyj7weqnU3t9iost2SdRn9
Pf3TB0FyfN3WKq+tat1z9Wte+y/94jfrJ6y7T37zYdZl/NbzAlNkbwQICcOQc86TzZeDTCw5Cno8
FXLWy+P0TGXV7Eqgnkc70n05X+wS6biyQ7lHAaTrqGwtzVmy+fJmolffhKVr3TR7S1M9ww5LNt2g
k31YOYmCTZ6KVTNLbEYrpmZ3PeuiXqYyR1SQUPNUFATAPFvlinQl2TnDDmGcqF4A4SRmo1U36o13
rnYCoVY8xjxmDYRiNX+EY0mWBoIT6ZxT3KPU49agx3NF7SKeZjiJdFxJ+GTsp/4T1ettBklvsjPk
RArFGIFYOIKkWQgZ9YKEco/qKJhZSK46nme9WtVbh0JreUd0OPZJnoVMhh5dyXOTvP8DcjWkhHrM
GmiZuyU1CEY03OnrYSRqQEItfd6hnjVQ3rhPAJIoSLMurQg+DHdNiT/aHNE+IwRGm1Ge+idRsNnr
iVS0WyuvAURBYLUk2UoKQ86vk4x6ow5nJIkCwYUQUqUzsyAK3F5PBKOk0N+OgqDjNdov+6OI65vF
9PxBte7mdptVthu5+/hOHpaTJ66sl0TX5rBzUPaRBSFWeVLRqtlN/FtcSQkAUipeXjWPfaIPF0re
YS4SIqU0kz0eQxxPVf+SMhOh08rWjf4Q226oO0+fuWM5ku2iwKIhPGQANiG5Y4VDftWfWEjb+Bg0
C0Nb5slDIaWSx1NKWZH4rjY+1le7/CTxfTuV7E6/PD1XzwvLvm9nwmpCqFSwjfhMSakTREcASKlY
PhzjMZOOZTmSjUuaQkyKPN2TzDckvnVOJNks2g/S5bYWyGPM5mY6bMj4wF6+Ok34uGXEG4VtMreq
qXhNVqgGqnU3tNuist3S7vePr99/4WIWh+M//F9efj47+2r/qzuPj+He22Egy94eGFkXN/e3omBg
rl+TKIiWPEaUbNxUU7KUISVRoPc2lCw2Qnhtiy0vZtipLL1zs5kDTc1Vs66pvgFEgViiTI2SumZ3
zU7W36z5ooDpUN5EycvSmeZ4Qqm/AGpgBqTmOQBkuzzczA6zfsn67mR73IhtiSDxmHJXEy/X2k5G
QtlL8YBwWw6gEyV2YTIKelIBJEu0FDi6JB0BnBFxTrKwLNo947VNy2tLmSVFoIDkutiF/4QxK5Dg
MVsFQnmNm7vlKRQPRNTxPNrJBo7WZ6+OG6Ul8e1AgsdIHm2iBsTvV0e4ZR6iWvfe7R9bu/s46++j
y/1Hi2H/x209NHe/3VM2jPx82Lb+uxqLc6X0Lebniv2wc+nSmjGbG+tn6epFLWO2obFciEOzkKt5
pLcZY4U+8jMU7SZ+OAnBnS4k/TSGfVba6zGyHzOeAANpM1bpb101vYFis1NTSmSVytS/zb269Gj6
cKHprA9CFKkbAAAwZsdCKnaWMVsKaWeK47Fw/p+9q4lt48jSjzfPZbRGIAUagYXRHIIBu3mYAZxD
mkAYz40BBB+maFTGgYP1xaB6r2YwisFqZGOYOlMc6RBjAAdohy1MDB24p7VFQHVZI15g3WxksdjI
aK4jwATiyDmMb9pDVXdX/8n6sUayXB98ILuq31+V1e+rquYr1KGXyaFwj3qWZUXUTdwQPduc+kv2
3hzHo3JFUbFYkOpmUdBKAYdNz8OM/qUU6QYASMYigeQ47hOqWncC+VW2c6tmy/5+1vn+ZdW69+nX
vuUnblFVvE80bt68efPmzZ3YmoyGsQZRBWvxlTfJBZmTpZI55IUajDEAaDTVEN2RXArKqtiMMU7U
SpbrLOesNaVqQ/ewbD0/5kZduQx4npxIk7AgWHaNQhPrJdcFT1pDNTmeUkATccsOmiwn39l4GWmB
VC11ORou1ZIBi+pv93DKp1T8ZdUxQUkHtNjTK6VRFhmNDE6dA00NZdzh1Aojv5618Jieh7tWHce9
3eMg+6t+c/IVY/Oudx1+81V8h+w1kq/wD8Zr8ZuTQ0u/CF8fsmb3KxFyeFi6vgcrnLruHXg77Tjh
1HWvdexBPiFQv1ryahC+IHHpwdmjePYctXwFhTSiNwMcfNC/mNJ5loMLeWWw9AIdDqm+2/l4UbR7
SPf4RvwJQfhmwJDuvt73BkFV635ToKp4n0y8FuxNQeF1hFqcVFA4TqjHm4LCEUE93hQUjhPtdvvT
Tz89bisUFE4h1N6bgsJxQj3bFBSOCIq9KSgcJ9bX14/bBAWF0wn1eFNQOE6sr6+/8847x22FgsIp
hFqcVFBQUFA4hVCPNwUFBQWFU4ijXpx8dv2TzXsz0+yL6QPcvHnX44XNZoMSMDLuLT28NZNx/VXh
qOWfNL0Kx4JdFidZe67NEOl0CDqAYHH3Wofsrav4bDTXmkZ2N982TdvfpQNrz9koy1zfNk2fSPfZ
5pztZ7jGVQDAgd1WOASkiSDNnHBQAsQGJ7oHkY7BbNRpFhM3iCmTkhNpsc25REs4EaMmRJpF5pMO
GQmVRnOtCdJnIzaTYW8VA96sat3/GPm7VNM+ar8UThQeP3781ltvZTahCgHWB6NWnjiAYFQhyO9v
V2rll3T07cV/K9++fYMQQgip5D9TJso1A5g7Ucvrgyok29aJci0uuFzLdm2iXCOEGMDYQd0+dthm
+3luhE44UIVH3y1fLTKGxAjwcd/+8PZSkxBCCHq0sDIitTLwZxs015aahBBje8W0fVQhlXK5hnwb
PuLXCWKmyRCplPn8KX9x+8ZVEgxzrVYGMR/8UAMJ5hlrz/XLHd7f2F5Z6EO5ViuXK9yepiGmuQ0f
LREUOEBCLS9nb4v/8j/3Zs6cf/LiHpy5Mn/23tLWJpy58oUoM3Zr4eGXomjA2c//Onuef3yydWlB
FAo4Pz8Ld198ztnbg00j/MH7PVO69K8sZrM6rnTmzOyTF5sJe/ap9zDyE0Tz3lJQLHtm+go8g0bp
nyEKDogQ/f7zc7l6QwmzF0pfzWwJRdyLA8VT4URBsLdY3hzlxrZpAjFYm+evuVkzAQbXOgTFMmSj
2QTbb/IcXE5rpcQ8ke1GTZEcREjRtgWL9G3TBmNk86aIyOWxLjkrTzWZcK1jMMleSdqi8CewESHD
9xkg0uTRQKTTIWCbpu0jhHw/YU9ctbguKCMp2jZLWRRFwmg2oS2ILxeCSOcaLJq2L6uQWAVCYHQ6
JE1PeG+Z9XI1XHGoEpFOB9nhFwK2rEp0Q2TtGpihERBclSTJ6vhQJi3aA5v3bdNGnSa0TZ+E0REX
jSBUGxWhKboaR9gnPqDBh1HbDGZmNF5tTvyiofdtcxE6WQZn2yO1ciGqWncG9ikfYAZmZ37zr/PT
Vy5M/3T7v/72S1Eg+97Sw+swy0vNnf95dP0B/P4Pk7+bya2mnal39t3p8/DsP3/7zlcXzsDM2Ssz
L27BNPt08sDxVDhREOwNFRBqNpuEELK98nF/QpAdt79s95/XeP5qbK+YoiWRNS8yKNdq5QnW/jhM
dhEz22yiTGplANY2/SCXJsb2yscr2zz7RhWR6wr2JqieJMfYXlnsTwTPgW23v2KPuD0G3FlxdZ7h
57Guco0IIL+/XZab3H4fjBoa9fuu3lxbakr0btvtS3JQhSB/uQ/NtaXKo4W2W+vcvjrRvzPSa5VK
zQBmj4yUPbY5xwwRCIKYuTgitXK5RoAt2wxJdIPHUw4nYma0qFuuEYL85eWV/vPa2u0bBDF7VKkg
8G3zDhIsBD1a7j8vk1qZR0FmIdwlmfWiShQKVBE8o0NQyELWbtTKeshNQv8Zutoso3LNAMaVTYxY
39Wbt6/yYUQ+Q80bNTEWwPwPO1cRwLbbF6zLANZ/Xvui+VJK3F95VL5aQajwaMUNqf+2219ZXrY5
GGpyrsSHMFPiiNk+Cod04vmj5Uf/RCpo2+1zESMxMyO4/cXlZbvvbk+Ua0Km2+9P1DLlx+0ZJZYN
wvmjqnXvU29aPgA8eXFrSQj5MlYAb5rNn+VfZi+U2F9LUfT2g9kL02EJvVt3/37lwtld/VJ4DeH7
dnuOI7EJYTSDHBqRa2S0wQCAbYyinSxEOmtrHYL45WtBwh3dB2yDAQvEz5m2D77PIB9sgxlEUhpb
aQvlIlQ8pM+2OWcyYy13L08CIk0DoIhQaFhkEEna49usGHkPRrNZZGFUjWYUOBFPtsGiq9EnSXlH
kJ6gERFStE0ezzYzmnvY4MxxK+KStj0iREg3RhsMwDbn5kwbgG2MjHA4Oh2DmXNzJjM6UuCMpsGE
HGBtZnBBgEgn2PVixl52M1nbLlYMAACjUrRlZm801wSa0J5LbqLtx+VOzogbTTGPs8wKZm+42iDZ
kzt9VLXu/ejNlB9jq9Pn4VlQQfvF/fxNx12qaWf5+4tZ2Prm58nzP2yazyc7fxAG5Pil8Drh8ePH
b731ncS6iLy/5faZnL9uu313olZBI5a5qTZiMYa07fb53saIRRshJLXFFnaT5CRS71BsYECWuiTr
2tU2ALdvT+jGyN1Gqf2+lJzA30B91EE2KFQRszLWkh1PiPkLMGJyQFKWA0Cwy0Nkdhj4xdK7k/lx
Qwju9J/XKqP2wvaHNz4U9z1/dMdHEz5DHxUZK0y42ygS6faX2Qhge6IcC1x5gpl2gVSQvcgqzQ+j
lr0/2wCYvcgYC0gRjECEJWY/qhjQZ4VapTjq3xnVMjd341PIZ3fciVqtPBEMXDk9e3ncymWZro36
rFCroDDayGeIXE2OcP48VNW6Xwl+8WtOy55sXb/7Irh49oNfbV2Kvj67/slDyYz9VdOevTANd7ci
6gbHF0+FI0ER8f+rvr0YS4x9e9GWPvLU2qgUbSl/Zm2e1BqVkAoAALOjvScyard342txGBWDbQTd
2X7u3BcQItLRt1cpmITbgwAQYz9yPAEYK1aMhL9S3PKR3GQryo+OEd8JDIcldtW3zbi7fK8tom4A
AGBUir69MTIMo1JkNhOEihPeNjQzOZTRJCPbtiPqJm6Inm2sbUa+Z4FtjMiaBLFYkOpm24CKAYdN
z8OM/sUU6QYASMYigeQ47ht7O1oCADPTrAGXFrY2z81+NbN16e6L2Qulr849k09JhEckYkcezp09
/+BZ8G7As+uxP+XS6YwMJDqH/XOuh+dZzs2yd3/iBgRnNF6F3nz54ZEQgDPnz8G9By/CUEhHb6T4
xEIUGpPnr8DmXe/Sk2i1M8vU3f1SOIngR0ukIwDIMIAx32iuVTbm2kx85U3y4Qz51EZ04CF2xt8w
GAu2kRKHSOTTFpC6HOtuGMYIEX4ugBspH8hGpBOd1M4QFIDFjiqELwZIJyry5FQ2Ak3ibIXR7CDb
tP0oNLFenQ5BiVMeoTW2afrFMJ5SQBNxG6FmRtBkOXLc4s7Kh1TkwxVZR3Wixth7E/JjKXrbIj/+
8nEjkI3JPTqUhmxh/OCLNANDMZ34UMYDsesRm7jW9DyMn0BK3GM015rGLnFI+Kt+lEtB4Thx8n+U
K36O8TiFHB78uObLrGDpc32vB+I5hIJ6vCkoHCdO7ONNfp12L++GZyH7NeHjwl48kl+3OHaD9449
vpj/pkFV6z5tUFW5Xy+c2MebgsLrDsXeFBSOE6ogjoLCEUE93hQUFBQUTiFUxQAFBQUFhVMI9XhT
UFBQUDiFUI83BQUFBYVTCPV4U1A4iXDqhUJBt4aHunvPXQXqTm63oaXv3sGp55g7tPT4fZae7RpX
cRi3FQ4BaSJIMycclKhtmHWPbg0tve6kbxBDn5ITaUm3hPMlatItp65bw0hl3Yl/js9kfvWo670p
KCgcBBqmhdUu4EZ16mB3a153jBvVl3QcWhf/Un369D6llFKKtdyOU9UGLqwOJht5fTRMs22dqjbi
gquNbNemqg1KKS6srh7U7WOHpdfHuRE64dAwj/6gulRyVktiBPi4jxtPhz1KKaXa+gemRxtVAHDq
hTr0doY9SikemzodapjiarWheRZQfp1qjq47GsVVPn+q95/eX6LBMDcaVRDzwQs10GCeOfVCt+ry
/nhsftCFaqNRrWJuTw+LaW4BHVItcIBGWrD2cvZ2/ZOHxoJ3/ZOHxiferQdbl/iH4Iembi0kf25/
865nBD+ueG8p+DF7SPVf8C4tbImrDzajn+0PLyoovCGI5c1x4uKF+Wtu1mzpQZOUIcfokpzWSom5
Uy8UdDoc0mTTUFJqxVlkZE+kIY91yVl5JiHLszdpuq7XRQLPb9CtYXCzrqftiasW1wVltOpZFkUB
qjsR8Q2VBXZGKiRWoes8bkNLLxToUBYV+SjTC6447KdbQ/lLQpVo0S2QjQivSpJkddz+JGHaA5sf
rjqlVgvjkrOaT6BLJa7Jgt5OD/NrWsvd2Qm/ScA9l3pWbPSdum6B1nLdVlI7n8pay+1hGFqWR92W
JskPv+0Vr77e29nfToa/mj/77vSVmRdhAYHNu96tmXd4/9nvRn/7+VB14BQUTgk00LRer0cppWPz
7e6kIDuD7jztjud5/orHpi5aEllz3YFqo1Gdcupvh8mu5uh1Z6pKG1UAp657QS5N8dh82xzz7FvD
ItcV7E1QPUkOHpv17hR1+d+V8aBrUo/bgwuWOXifZ/h5rKvaoAKa1x1X5aZBtwu4UfK63fVqb2fY
k+jdeNCV5GiYat58F3o7Q7z+QX0w7z7tTHUt7/0Gxg1cWLU8nLLH0gsOFoGgmqNf9GijWm3Qwuo8
dTSJbvB4yuHUHL3uaHTHbQn7NW9+3uyO53ee3qeaY3kYazC0dEsTLERbn++Oq7RR5VGQWQh3SWa9
Go5CoWHBM9yWFrKQnfuN6vshNwn9X9U6vapWbeDCandcbTWqk95qd73ae7rEh1HzVrXe/YYYi8Kq
13CXNIDxoCtYFy6sdsfz93svpcR/MderS1jTYN0chNR/POia8/MWh6P1OFcadLuFHJLtOZanhUM6
NV6fX5+iWBsPuha1LMvxxMyMMOjW5+et7vp4qtoQMgfd7lQjU37cHk+rt+Ru8vw5gnpv+Zi9MD17
1+Ms7fqDs0EJb1W3TOHNxtALSQWNJ824F2SsWutr6jkOADiOR+NZs9vS+OWvg/QW91wqPjqOI5M9
OoThMH8HDcBxHNySlMYS5tAejafwh/CZ6gXdwZkZfxIa7WGAkqaFhkUGtZL2DC2n1IvyfNzrlZyQ
POBeFDgRT8dxoqvRJ0m5y592YaPWapWoHlA03EuxkD1Ca7VK1BLk0vJoS0jHnuNwgqhbAI7j4XA4
XBc7eqGgO9iVAod72LFCuudgLkiwIBhauu5gdw/Ux6nTEsYAABiXqEyHcW9HoAd5e6x7cpm6OSOO
ezs7Ls00UVp8CGyS7Nlt+hxBvbdfwk/fjYOaZ3JdNIiVWAure6u6ZQpvNGTWReX9rUF3Vc5fx4Pu
YLKBNc/J3FTznBhDGg+6fG/Dc6KNEJraYgu7SXISqXcoNjAgS12Sde1qG8Cga01Wsbc+1lL7fSk5
gb+B+qiDbFCoImZlrCU7nhDzF8BblQOSshwAgl0eKrPDwC8nvTuZHzetVLC64wb26h+MG/fnxX3j
dcsrTQ5XNVpyVmFqMC5FIgfdeccDGE9WY4GrTjq6BRRr1kUH9+ajlr0/2wAcq+44TkCKwAMRlpj9
GsaFrgMNXPK6ltfI3NyNT6HhqjWYajSqU8HAVdOzl8etWpXpmtd1oIG1MNqat6q1lpIjvOs8PIJ6
bwAAsPnkBQDAk61LYWUcgFsLXoze/eoMgKpbpqBQKvH/q0PrYoy+DenFaD/sokitMS5RKX926jyp
xTikAgDgWIEg3KNefZcTj0lgjB0n6O7s5859QdNavZ0e1Hc7jHkwwS0c2+uR2I8cT4BVp4Rxwl8p
bvmINjs5YkTW83hTMCyxq+JwoWxsCywrom4AAIBxaWg5Hv4jxiXHcgShEkdQoZfJoXCPepZlRdRN
3BA925z6S/beHMejOxLEYkGqm0VBKwUcNj0PM/qXUqQbACAZiwSS43ggnPndf081fjyD//d5Dj67
/O17l799788/7PzfD3+6/O17nR+//2b43uVv//TN38WV4N9n/xEEJro+/PKb70XnnZ0v/xx1fu/y
9/8eRfLHzy7nNSkonHJIazIaxhoAYLFnL77yJupGt8irONkLNRhjANBoqiG6I7kUFArqyX9qMVcc
Gol7UYectabIolCgbD0/5kal5bV8OZEmYUGw7BqFJtbLTQRUtoZqcjylgCbilh00WU6+s/KKYcYA
a5RiiI+lS7VkwFyqiS49nPIpFX9ZdUxQ0gEt9vRKaZRFRiODU+dAU0MZdzi1wsivZy08pudhzKHk
Pbi3exzSA6Z+c1JBQSEXQ0u/CF/v+8jaEQg5PCxd34MVTl33Dryddpxw6rrXOvYgnyio17oVFBSS
iN4McPBB/2JK51kOLuSVwdIL/8/eFcW0caXrnzdWva0XCEYIyaovY+ob40qNZHNFvQ8mK80dqDpW
K5U1i1Yi7BMDfqBqvVIaxE3Ig7eKHwz4PhEibUlgV6qYbrneiVRcbSAVdpRI15nIqceXyFVayaR2
ud10iZSH+3DOzJwxM0CTJmSz5xMP5pzj///Pfw6c880/5/yTsjzZudf78X96p66u7p0/yZMHPBH/
jEA7GSBP7v28758Oz26+N5q3jIKCgoLikUEfTlJQUFBQPIegyxsFxWGiWjxz2CZQUDyfoLE3CgoK
CornEHR5o6CgoKB4DkGXNwoKCgqK5xA09kZBcZiwir2JYxNDKXs0NRp1PYJUeYhZEl3BSiq4b1Nx
bGIohT/z06fnOfNm+cRMd6K8RwNxbCLmGr0a2XUpVyHdzZWjSj+vFsS4iVjBpGtIBQC4I2ZyKJ4s
5CFmSUQfiZmjDYoKw8Dpk8cVvMrJMdfoPJPu5tJ5vb1nXunnTeToWmLcRKzm9XyuvzLtMVS5gvOM
nI+MRpWlxjEZ0FwF4jNnmMlIyNPO93b+5Gb1OL1SkoICY6f6V9Nyd28QUhng/IGmR5BqD0Xs+YX7
ocH9/tQK6RMLzi8zJ6KRYDQSDFkvpUe6/DzI601+qzbu3uBwl9n/kCbncKTTTRQEBs27dqTLH40E
eZBF8JiLeuYR45a+HTR09h8H9lAkGOVAzDg/ZGTRhUcHjfu9wegX08FoJBh1bb45uRUddAJa26C/
8pf+aCTIV1a6E2V3bzDU5Rx2lWPQg8qjLrmbk92RzgCaP11DXy68EUWKUjA86AQ8H8q/zYzNR4K4
auOF4V67ODYx1zWK2vOVlTcXIDDoD3R1InvmOQBXZ9RVjkHPFxE7ALh7g2j+YC299gM8nLz7zSBK
z2bM6wZgkacNtUcp33CDW+fv4vK5u3pygP3vmbTIA4eSxg0u72zi/APYJKtyMMtLt3d7Coqnh9RS
IzOBfmp3uEq6G1fNkDtccQy3b+TSMU6tKmiNjdtYQn4jlzYI4dL5Qrq2qkAoTSwZrNKr1J0+QD4x
Y2p8jJuw7Jfxi6Q0I+QhZqKRmxlCxqSQ9plYQbWEm9ltj1E1Lo9xend2+VMe0v2GNKY1Id2Jsmqn
rkKXz810I78V0t3MRKxAitL7iD6jUUOu0EawO1HWB4hLY8ljsmGgubTm+aGUNqCoC1gjqQ7ZT7i3
duitkE/Jr0SCfG+zmDIZLwzGjvobA8yxAMAdGa0oZsye678a2YoZRl8e4tLgCl7d9WgBMzxX8Oq0
BwrpmBLUSLw7MlpRfvSTjAOwtyNNb/kgvbzTc/bVmd+09sA38TzKAGCRp+2lF9/yQXr14bFQ82sv
7qRX/3ZMePVdN8BLL74Vaq3L7rw1/N7ncAAAIABJREFUrX6lzVShBss8cK8dbx1u2zn3h68+/r55
fbpjuO2781839LRZlpvmpdtDDgXFU8NO9a/gqnO7+ueng9FI8N5kbK4Js6j1hU9jH/0wnIr++T+D
Ue7++1zmSKTTvWvXfCIFgUF/oEke6soEUOOIXeSWxCZndNAJIA9x5d8peGvMV1Y6Ju+j3be7F+/W
MXvDVI+Qw91/P5I5oj4qvLeReT+xhezh4fP3N15GHMuKdQUGg4gURl3luYqTrFpfyADndyuZuY2X
55WxeYLe3dvIEHLsoYg9P5mB6dNf9G6+OXZnOBX9sCnze+Xl4d7OYQ7ExBa/y54YNyFyeNcfdcnd
ka3ooDMwGITUp7GUfR65QvenPMQswfTpL6ZVv6kPzQKDwair/N7kylzFX8mciLrkmNIZckE+MfN7
F2Yh7o1P5yrO6KATmpzDEQMLQYNIsl53r+4Kdy/mGVcjdo2FVBb8gS4QK11fastGb9BdkN2T/QGX
c5gDceGHQMQfaNwSF+68Ph39sAsA7CFXWXT1/3kQjwWkyr9NveEGuLeRwayLA3Hhh+GF/n2fBMxN
bgYmO92uurXJOxr1v7eReX/y01giHUukYyn7/F+CbgDIZOasSLYixwr2aC9emY5UNt/b+Jdor/3e
RiaWSMcS8m08M3WsL/zxvcn03Mb9I11+LDOTmWv0m8o32rNV89iAnD8HfrVEzfTmbFMz4OyRp62t
9aOzDasnr79+stpz9tgZ396idSEGgrVfHjhn6Og6yhjnc5Iqasv3y0tnJYeC4imhUI6pe/maIAQ/
re5YXcHzka3lFADIy0rQuGsejboAUjdvR95Rt7ee+VQQLxipmyLBTroTZSiULaiS2p4LEkoNMTDN
HrfLPFR/YJRj3ER3ylMhYnKWcAXnOQDG7tYM06CW6PYU0iLTr4fuuP55Rta8yk+r6jR/pm6KXL9K
Ozzz07WXh7kjozgQpTZzR4KvqMRoKOWZP0CA0xTuSPCVRBqTy8RWNOJBhvHKTRERRC4NIC8rHm04
rqY8IjfRyMl8iqBKXD+fwnIgtSRyQV61fJ5DsU+ZP0gQN7UUYzp5AABPiEmTDwD46dMV5XRFOV2Z
hiHjg4Qf2eVRixH3zCunLQKu+uzVSC1hz16XvR0s9qZmegMg8rftnaft9r1z2R2Ahw3/ZmBpN1a/
+3lt7I1IAkfK2Vu+IY0cgd3lpPEAQOSl20sOBcVTwU71vwjWFSTjW+sL8pFf6wGqexuZ9SZ/yLUl
mgbVFNnAkCp35lBsQ5H1QAj+IYJDWjNCTs3WWxOrGmCmrpZ17WkbwPpC+kiX5/bGfXekNlK1S47a
38qduY0XhnvtegO1xKCCLAQAgNupzL0uf6DJwp9g6C/Alkg6ZJflAIDDVJiYYnao9ks+siv2Zu03
uxs+n6v4Q8rSm992/XkQ2/Dtxud51wv5lP13jCzWvbD+rV3vTibzXmoL4P6RfzcESgNNcneiLtpr
j0Xk0HSXbsDB1zYAMfFHMSUjViQqcBuwWwz2uzp5yIh1/hCzNTe9NWwa3DVOoXzq8/Um/3DXC+rA
OXfPXuS3QBdJ17bmUnXDvXbN2+6C7I68EWj6EfPwMQ4GWOdp21y+9fosnLlwbP2CE2avDy7vEJV/
v4OYU3Zzn1jXT5UHbs+8dBQUzwCa3ehvtZA+YYhSlGMRPR52ItEc4gDtrIlQljyE4i5cp0YFAEBM
qG+vcf1RZckQitsbXCefuqnKkYfU/fJPDbs70l+ZhiHLqNujwhXklTQZV9PZD+lPADHVHOJq+kv4
zRp6sBOBITnHVh5VpZbIWN3tQhkAoJDuNvrTHQlCIq1TNwAA4Hub84mbtzkP39ssJuRXenFVPjHT
OAbzyumK0g9jxnAm1x9V0rGETt2wOn1tk4f2ib3Jy0oQUyLldEU5HVVumg2NHEuAmwFwBaOm89Ck
fXPUjJbFuD2HvnYcHwUHOBjwf38bPPnNJgD4nOv+716frQKAM3T0o1A9QPWUYYlqOHPB6Vy+hdaz
HuHYGdg0tgfI4hLUuGcf80zk99QWQo+Ann9alQPc/QZ34YDtKSieFqrFM8Q703aeAzFV5qdPh/57
YiiFf0VV5AvZ5LvU+sv6qSXt6Q1wHj4lq2Ek2biK4He1a1/IVt/GJuXwnOe2K3g1YteMJF/IdkdG
r0a2di1RWL6O1FJ3QX9NQDsY4E7gf4jWcjqXUaErWElAN5fOc/1XXenuRNnNeSAl55HZvTcJe+xQ
MLybrvknxs3kGc2fxPGDGr8p9nkTp5FySL8ZO6uLIsp1e+zRSHMsIZMnH/KJme5C0PCQTV+W5CEm
7U6NRl1g7X87oRpIY2pflN/joAhpIdaL+k7OQKj1m+k8LNQcDMDlJgcDTOah8bhIjSiuvzLt2cMP
uw8G0HNvFBSHiWf8zsl8YuYEvPOYp9B+EiGPjxg3A4l9H9PJQ1z5kcNphwnjHoIC6LFuCorDxbO5
vJHHaQ9yNtwM5seEDwsH6RF5SPnQDT44Dngw/58Qz26+t8MCzTNH8TTxbC5vFBTPASh7o6A4TNDl
jYLiCYEubxQUFBQUzyFoxgAKCgoKiucQdHmjoKCgoHgOQZc3CgoKCornED997G119vqpbP3w2aNP
7maQ8yevz919siooKA4XpXHPmsR4RdHLPMK3pTXPeIkRBsSRgynCnx1xOcCaN9tO8iuzyh4NSuOe
HCP2jewyV0mu8IpXjjvUghzvySkmXUMqAMAmmMmheLKQ1jzjJfSRmDnaoKgwDJw+eRihj5Vy7WKg
PbnCz27r7dmAHHeYyNG15HhPzlgDbHwgzhqqGCHQLm2PiN7i+MVxCdBcBeIza5jJSMhPn+/N6W+t
y26BT73U8QngteNPXAUFxeHCxgpweRHYcEvjI3ybcQjM9mLVEd7vGh4lubbof/vKBa8geAXBYb2m
1PvCjrrL5cawVRsbK3T4zGxt9HUIrI0oaAmbd63eF/YKgqPucglYc1HPPHL8+IOwobP/OGAcguBl
60rX/L52qdSORweN+4Pwlb644BUEL5P97GzRG/YBWtsgPvBJ3CsIjurUyqxiYwWH39fBFHMgoHIv
I63wkk1gW9D88c+/feGUFym6DB1hH+D5UOy48klAEHBVtrGDZUrjnoJfRO0d1anPLkFLONziZ5E9
ARaAYb1MMQdCn8AAgI0V0PzBWljmwJdytdU77+5sAtRcpnX+5PU5fJ2jXn7+5C0INazOonuwdJqF
GjtDR8/A/w4u7+hf0W/qAmhrxff3G8v1a700FSNHg9lb6oWW+1zxpdvZVu+Eho/OtmIKGPrZ3DJS
QdBBa72rs2qaurbWYajCyNETbdb2U1AcBBLehIKRuOR4HkbY0jjaC1vumr0gwTnRyyCehDfOjngc
ksUA2oMT8smNee1uV6vS5TBeoT03KyGrtpN8DtjtWVSFd+VgzbrIXfmuKh7OiY7L2o7eIG0NzqmN
EQ1lHIpSAsYbR95gvKLoheQKP7vNMDZFqbHHqBqXY8ootOdmseMIf+rExRGPwzgmvkiITRAD8O7K
rEKqIFgFYwO2TxwhnQ9YlBxgDawXORy5QnO+TRD72pN4gBjBC7M5RacvuBkjDJwDJJ9gLagL2HhS
HRrKWsJ0ADa/neRz7WIAxleKI9p44ULE2qXxixI7EGdBSa4k2/viZlxea2McUPVDcY1XZ6Y+XuM2
MW4jh15JrrwLfWYGm9tD1GpCHiffm2UetRurX8199vDts6/O/KZ12Pfw3Ml7Pw81OC3zq1nmdYM2
cLb965TQOhxq/e4P//PxS3rygRurW+Brdn699XH+xTMXjk6F9soAvrl863xbB7LTmf/q4+9fHD7+
4mvHW+uyX81lf3YGqSbstNK7Onv9FDhREoOe7786lYVjx5tfe8nafgqKg4ABGxMPxAWvIDyY+kWh
EbOo8uJU7lK1Q7zyy1OCl61e4y/VC6xt1655TYKWcLilUVr7xWILaiwwJX681Oj3hn0A0hpf9Mp4
a+yoTn08VUW7bxuLd+uYvWGqR8hhq9fGL9WrK9OD7OK12SKyx1GXvJb1IY5lxbpawgIihV6mWKj6
yKry4iKwYVtxsZD1BeRPAgS9e5BdJOQwDoHZnroEcbmPzX42nu0Qr/iaFnNFXwfLdrB1pWTRscue
HO8psXjX72WklXeL3rCvJSzA5amcxASQK3R/SmuecYjLfXHVb+oy0BIWvEzx2tRUoRoeuHLBy0i5
IutgYDvJ5xjMQmzZqULV7w37oNHXIRhYCBpEkvXaWN0VNhbzjL4RRmMhAxfCLb66UjX8tvr/2sYK
tuJl2wfxFsbXwdaVFqstI+GWxmJpMdsSv+LzAwDjYIolJv7LMB4LuFzsED+wATzILmLWxdaVFqsd
8/F9nwQUprItH7A2BspT1zTq/yC7eG1qKpdM5pLJnMQEPhFsAJC9VKizINlFKVdkvCxeHesr2WvZ
Ri/LPMgu5maTuaS0jWemjvLi+LWpZCFbqfeHsczspULjr0zlG+0p2v5jhGxGzp/HyPe2Zx61HkFl
Qm2tZ0J/TxMX/9fmV9sjr9vdnfOzuHyOyNAGAAA7cyevD2Yb1nXSZpE3DsAZanXifNzXT2UbzhDs
qkdQv07aaa63mv66dV1o0HtxAVG3ffLSUVDsA6WYG/dc9HguemqDEI64yjCYkYBQLEkAIJWKgrZd
tY2IA7LoZQAkaVs4p9IRNiAKeMGQpBJIax4sf2VWAUUp7WGMJJXYEUKp4VmkZo+tvf0x+5zjPSsS
O0BQLkswQoAFaGdsmmEa1BLdHiVZao/rTJGNB9olzauOuKpO86ckldi4GlBkA7voiE0QMelRm9lG
RmyzPPLnmsQGDhDgNIVtZMQ2m0RjkUsWvSMsMsxRlEoAOd5zkU8CSKUiqw1Hn8iWeM9FXnKIRBCU
jTskLAek8RI74sDyxQCLuLjkOEgQVxrPtbMOAADW0T5LMntHXB6Q5QFZHojDmoevDZUdvMuCaDHi
bECW+wRTE/XZqz2EIOyxCAUDwGPle7POo3ZjtdrQowfGvstv3XipGROv3fnVLPO6VU9Fto4hChhq
7YGqLgTgxuo3De6GzfxDp87bLPLG1VQZWKapnVZ6d9KrD3t207K989JRUOwDknUJZHyrvHi5/ld6
gOpBdrHcGHYwxZJpUK0oGRhSJVtAsY2ipAdC8A8RHNKaEXJqtt6aWNUAM3W1rGtP2wDKi8l6H7ud
rdiE2kjVLjlqfyvZQraxg2X0BmqJQQVZCAAA29LiA1+4pdHCn2DoL0CxRDpkl+UAgMNUmJhidqj2
S6rfFXuz9htjq0sWKmFHcfyz/2fvemPaurL8YYIX2wtxHg40LwgrDvZbRJKRagkyyfLFBK1ljAqa
/ZBtZWVLmC+QYMmptq5EidI2lYapGq+S1HwKWSXN7KYfKqOJxbpyYTVK0wRWrjSRKWvDuDJKnwUx
xi61H8IT7Yf7/trPhlDSpOT+5A/m3etzzz3ncs897557z/Lr7a8buPqeVEN16gvDkQZ/DKoXlxuE
7kz/5//65wGWlS2SjdJXqv0+DxyxGB6+5dddel1gYPO2DSDmORfz+5FXFJuHFLBikfBvsOjK/isG
r+sa5iOeeUp2c1c6hFJfeBar/4VqruYU11I4epHcXml+Xaz3iB8oi4GXtmb+C03/u69UP8U4/AkH
A0rlUWOueWj28SN6yKsyl9jhLpXXTXWgjifCSIuU+m79V2dgqHTSOAAAGB2cEafnhv38XpqIT4DJ
aZ5P2XYJ835alLsuOfRmcGh6+/LSYby8aNCg/9U5z11JdNncw7c83FfP3U8adBZAK2ufh6/mv3vo
0F0/gMXCuwIAEPNw+0CWS0fmz0n22ErDYtH5/Rwd/91zm//lU8Gg6b/0xiUQovW2jXC/bt4jci9E
3o9YngAxf4POktdfkdyK42GX1H2ROLLzKVTkP/dHUddS83MAAHMen1Semv5+8HgE1w0AAHSWhpTH
n7L8k87SEPP4NRZhE+uP56A1FHojdAnOHRKNAaRlz0OP4LqxzQm2zX+3S+i7HPyx+TOsSxQKvREK
HZn3y6nG//AT0DQAGPqPyI5DmfoNR+TiYB92lVR9vh63gp+W700ujxo6GNDWDBPTyBLwIRsl8qvJ
5nWDqJePHGEJop/wBwMOeNlAj7wAkDyI4l8gLwQmup/nUyBSrN08Uhvyj4GxGYhCAAw6C8T8c7pL
IZ3/0F0/+ycqEoeWiKM2hGB9cQgJmrXZbSS/1IqIoy1EfHDhDGI6OoslZehHcQGISXFAtubMmK1/
vsBESaI8EEFxqAJ/MEDjEYVXyNOxxNBDPrbCcslm8Pg+mdNYLOD3pxDbFr+IH0NelAcvn4ddXakG
Xp6iaJc8uc0bWmWEJqYjlpu0swIp0fMioTqoMOXp8s31S16yCWbJf/eQRzM2dsQAxeVvEDUNYmaK
hg4VQsyhKFyFH5DiutLop4JxWDLERtpq4TiUHhfJI2W59MYlSwk5FB4MeKnvnEThl/jwHAZGMUjj
GJ8nkZ8OFK650Ws6f2Fc3y8D0jUEBrzMVyqLjgrgUH4MDAnEx2k3czZcDvLHhJ8XNtMj8XGL587w
5rHJg/kvIXC+t2cFnDcOYzP446FDz5sFDIydiZfXe8PAwMDA2MHA5g0D43kiWBZ83ixgYOxM4IwB
GBgYGBg7ENi8YWBgYGDsQGDzhoGBgYGxA7H9CXF+QYh6Zzp/vzDqpSeBkNwThoHxc4F+j5Z9nhkx
xUeIMt9SRWILVIlErClhA82N1Q2rZkZM8REy7STTTjIXptVFAqXXnU3ff1ZfokJmxJSgkpX3c/kF
FBn/puZX7hUF9yAdMC1elOkaaiLtJLMgRwfj2YJIxJoSTjLtJNOikcMrhftIFCcMHhuotboV7ZK6
jIx/QyWF+kqFe0UhQ0doJR0wLV4kJUUUo/ExkiIbKI7pspGlit/oF748yI5VSvQ9IhnJiAgOLYGo
d2YIDpa49AQD49mhRGhJOtAE/TO7w1sjTCQCSm27vO0UQJFxD+zbsBoAAKw7m9LhGa1va/xIUKJr
686mBPx1n5uRKXvhkQ7oy9uj6ufNxtZBkXEP7I4QObegHYnebfoFJ1PfTgNa0EC0vi+J6sSdSnVf
UOsDsOkXOlfQc7DpF0ZAq4uq8zQrHXgSuVFk3Mns60tmRkzp8Ayqv+5sijtB0z6zO1zAD98Wxy3f
yibNm3DpVNsZPXwSnagjP21O2r2M6CIu0c1YRfKfFcn3xhJHpNgLsUoetX6qvHGl8roBgKx5w/ne
MH4uBMuCYNMvjLCZKBTuGX5mTweawJ3MjJDrAAAM+t9GyIyYEjYAAAjTGiBYU0GR8QCqDOq+KDg5
8yaiD2G6nptTBCJ5RQIdRuPOppwE4mrd2ZSG5LoTFSXRnAXc1JbHPACkA6YUBYX9As68qWzsD/Oo
icwbkYjpM2FGTSkzwGj6kDQYTfvMbiDjAXI9zCgoZR4/0qbZ5+mAKUWx3YF8eRKJmD7Dy21EnwnT
9e00IqJwz2jhYNypFDch0A8zCkjua6fFwgeWVFDrk8z7SOBIFLzwFe6ZfWGSVVCY1gCZogB8rNlg
q4Xp+n5A9NV9QS0ghaIusMyLm0Oq5PVSqPpiYC0H6OMUzetL3pxwRkiGitTk8ArlvqgKF17IvCmK
2z8ZJrfJvOWG3owCe79icujN6AQ3g0e9M6N1Tey9i9NR+yPy024lQHLozRUzd+li1DtjnybyM5Qi
CtPRIUA5cfjfAgCMDkYPfLjRnY0ydIq2OzoYvPaIM4GPaPsgc1p0J6Sc95acmCbauEsmo93s3ZJs
vrczBEvfC70fNp2uK9lfDIySCJYFAYiMLan2AQCkA6Z1d1DLfU9R3CxMkfGAcrcuqpZZNQM3zZEK
dspGVgFNZ0QitkclNkW2pDDNyUwiIjoUGQ+Q4JZfQef5WKW8LptkugSJecuKzZIcHSIR0wM7p6s0
7TMqG1eBIuMBQl3ATzpgyvg4ayryNtIBU4riTJQgT46+L09uLOcLIwRrGGz6BESRCeHbyoyYEkah
vqz3ljcd86KQ9LS42ciMNLG+FN9fIOMBUsHynC9engehXZGgSoP7rcT1l5pJToAFOhWrW2JyuD8F
OgWGll8uCMug4vTzzHbeykks1U2ElkyvTKDEbAAAxAdcwrNS9UvmP8vP9wYAzfq2aZqtMx2daCbb
AErkb5OnU7Jd+bxuxYDzvWH8nKCU6RHTQsy0EBPcHQR1HzclhWmtW5W1AQCRNdL83KFwz9TrZnaH
AWx71t1/5eavpLadZve6bHsyQCRiLP24UwmUMlOCGduejI8WNSqZX3h+FOHsT+uzMhUwxW3Jet0m
XuWFaa0PIMIoeMZ4cE8EfigyE4kK850vqo0QaU6q6j6uOV6etj0ZX5R745rUFrgjCvcMOxdz1RRu
WuFsQvJM2JIbvwEuAoWbVjhJpIu0U6VxJxFjauOeDEA6YFoIkABE1pjk1bGvPZkJmBYChLo9KLwl
9kXVNpYO2PQZH63mOH8q2wY2fSqyogYASKoipNizV/cF63XBel2wvg8SsaY0VYzEhl2eKaLxpFYX
LPJGWhi9/EsIET9y7iOHTYSWPM6MPlL2CnndmMlp+O2JKiiWyK10/rPCfG8AAPDq7hW7F3pbVKOe
FfOZGj1AyfxtT5U3rmT+OYCV2SVpaAnO94bx84F+j0l8U6Ns/0vtu7TGTauBWEssofCNtVPErpvC
Nv6TYzVriSV1RJU9Va4ujBmhiFXtqhCRoa1atUHljVWgiHRZvL49qnHT3EeI8hCqiejwG/sAsEtb
yZPlGJBrDuDJsZqiISEFlddOkbvuJ9ePlSvEzMjT4fqrrVo9lqv0MUIF7omkCfFDAABY76x5cn+p
IlFEniDpL5SpsmKBFHAOAACMmhdmmIiPqPhAjLVTxK9uyPSoiNwYBez/UbukpvSLex/X3mB5+Nux
/blIbt3G7I4QWcit7WWE7vymJtmpAijf9bUkxqciQcTPlWl8THqEUPU/FhjYvG0DyJw7mLURKC4j
S8F6GSsWCf+RFTXUZGFJHVGtOlWVsrFL0iG03rl/LbFUeT/HKW61cPQiuSnvLwmiLlOtdpZV+hhe
2gqK+Dv3QkXiKcbhJry35j1t0yu8OzLhFTLgAED0EQMA8Ii285tPW8t/1qzv/Z4e9fKu29OjVLvF
8roVA873hvFzIluOZh+KTIg3S0CZ8nBvuSky4cyqfIBW1qKXM0QiZkrYAHwrvCsAABkntw/ki2qM
eskeW2n4VtS2PRwdIjGy0duaLYJRuKP1fcBvem0bwrTaSIrcC5H3I5YnQNaWVfny+iuSW3GkA1L3
JSL2OVQ5VGTTL4i6tk4pAQAoMi6Vp8JNg5MUXDcAAFDfya4796z7kuo72YyTUNwRNrEWRkCrC9br
ojBikuyr+aIaI5l2Cq4b25xg24hEoPSOCZE10qxLpAvW64Ia4x451RBpJygiAGF6t+w4lKmf3S3n
lqUDJVWfr8etYNcuckC5wcEATVvdin0wOuqlR730ZB3R9kM5cmKIqtznnujHXnp0IvfP3VUT3gXk
Br16Qjk5+O2Qlx5lP4y+m9BDcujNb4emmZXZJfT8uzqyTRTi8eru1bM34a13ajZyfYrSKdIufDOR
JPYzQ54F9HzlxMG3GstZOl7689kcRwrVV+mBHvj9wqiXHp3ImZrLJ7wLqAl9C7ly8y9nbyLiK3ou
31uxdjEwNgT9XlQB+5dQzPQphdKXyzjrc2EazpmSxxj1fVVihC2qao9UJgAAFD76ycVfc7HUBLcH
w6jDRPzLg+zqO5JUH6tBZwMqbjDZL7mYb1GsdjpgWnRWPdFWSaOxxXQIhS/5JLFaeT+HNjzWO7mA
7BGCWyZXoYDy1WPlT47ViOkLkC6x0wFTisopbyz97V8PZilVlj0JIEunLB3TZ7RVaRtofLB6sT5J
MZWJqrSTzFLK1Ys168hRAFLET67ifnkywMemE4p3I4I3HOHk6SSf3IgS93MyctPm1DdW2UD5ThXH
jHBqYu1UfYoXZicjvAcGqEhULn52kH3OvYXbtVy+OnIwiZTo/iHj1IncU0ah1SXKaN51AwAoU6Uv
VqmH6Ir7ZWsXqxT/vlSR4DecVGVhWk2RiDGxm1uRqFy8CMRJwXXLXKRWqfK1U6wc1hOrRQ+KUGT8
m/o1bRUX908kYk2rWlXWSeSomuQp5XqncDAA3GGtL1d0HFJk/LOaJxTB11f0fauJsPzzwkw7yTUt
o+bGYYpSZQtOHUj1SGYjC7U3mOLjMIcOBgjjh2LKKl79P83THQxIDg0yHzyL0AlpgMk2Aud1w3hh
8YLfObktYfovSKz/5g5abO5AxQuIErEeLyuezryJw+K3MThQICtJgb09wHndMF5kvJjmTRT4vnE0
eREI0fY/gci2YTM9Eh+3eO4Mbx7iAx7qvuC2HEzcGdjYvOF8b1sDzveGsRm8mOYNA2MHYAsvJzEw
MLYN2LxhYDwjYPOGgfE8kZz/4HmzgIGxM4EzBmBgYGBg7EBg84aBgYGBsQOBzRsGBgYGxg7Ec9h7
m/gkOFrXhBPQYGBA8b23sYHzPeO1rvGzLuMWqIZ6DLfHjOblcfOGVccGzveMs9+7rrx/3Spfbfby
1eOXF0tUGBs4P2w8e89Rm18QmTxuXXTNneziHgxbzw9HZLqGmgCARoccHYxni1CP4fYY+ioaObxS
OEgUJwweo/meNTRsPHvdMHncOjkr1D90fe5klwwdoZVh6/nhvPB868nlK4ckRUbzdUNo1nHWNXe7
eiAEaKyC6LtVMpIRkV3lG99ass3pTPUtJM4dioGBwCT/LPu8scMM41NgbWnVboFqbbejdvbWj932
jS7PiUyevqUPT512Ocwuh7m7uCnde7SlC0JfaVuK1WnsMPcelZtDtPpex+FG0YNWu3zX9h5tcTnM
XRAag0PypF54DFtvJ+ySzv6VlxvOAAAJiklEQVRyUNvtMLusMDal/8gQGjOy2kF6f2x3fX3F7HKY
XcboaxeWXHY9INsGJ5f/+6TLYe5a9h2/vNjYYe4+qu81Lg5DG3ruMoaOW0ONjsOtaPwc7Qnf6nSh
hsah164Hdjws/m5q4LrDzBY9+PvejtqxgfPXjp5F9buWfa/dglZ7S+vRw4if61YA42GXcXEY2r52
1AJAY4cZjR+2lY7aTb2cHB1k78KPemckN/dPR4Xr/AdFpyAf0Xb2+cyoN8reow/A/TwourlR0oSE
OCIyOGOXSxeAgbFzMH672nAeffJXuHOTx9miq+IV7tgAW7/aOjls5YoifGXpMlZEv9o6KSFinZyN
TOYXRUSNXr4t4Uoo4lb6ALOXr8oyP2w9X7Rf0h+KqUkR6jGcr7Ze7UHMjKPWrw5HOE6sVwv5kTbN
Ph+2Ct0pkGeoR5AbanGSJ3L88iLHp9CEQN969TiSW2TyuOH8cERMSugj+o60hkTBa/D45UVBQdZJ
lvJASKJo6yQv+Z5xXqGoC2yL4uYQ/yLx5qu+GGbHQ//gMHd11IyNy+iLhaEW9XcYWB8LABodZ5fn
5Dx768l7jqVhifZDPdZJMJrvFbxaYD08o/nelUMQmRyeM/NOfKPj7PLcU7/J2JT39uoJsreO+fjm
wuc/1Hx1heqtWxn9nmirSw4NMqf/o+liN9nbTbb9sNB5M9d7okpy435z7mPPEsFlBCUaa9Ad/NIb
+mF0MDjR3OR7p763m+ytW7F7mN4TVbC76rfNMOll2j789dVTZBvQl2ZlUg1gYPyiwST/DMayRuPJ
61fMLof58YXha1rWi/rq1p3hTzO9464/vWd2WX982zq113G4sWDVfHocWu0trdpQz9GpVlTZUTtm
vT2m1bvseoBQj3XxnTl2ady17KMu/IhW340d7Gqd9d5YV09Ex/rj246pvdyrwscPpt6+vIT46YL/
efvBAeRjFfO6Wu1m5BS6jIvXlvXioq9uTYG1pXFu6tqDA9fnBq6L3LvHD6ZEdGq7HbWzF6bgyvtf
d0RfG/iud9z1kXbqD3MHejsO91ph7PJSVwE/w9bzY1Z21e8yho47llx2favdDON3hsdrryNRCPIM
9Rhuw5X3v77CyY17adZqN7uMi/92wXdtuWV56rTLGBqeO9xthNnLV/9gZL2Qxgd3ri3rXXY9aPW9
DokXgpQo9nobOwRRNHawfsY9Ry3vhSzfamk9CmPLR8O82egwN0ZCjRdOthr1vVYYu5VpdbS0Vi+N
3fruH6+4PjoKALXdxsUx48k/2VldwPji78Y7G/+/vauHbduIws9Al8JFAf+IQOJJhQgToJcOlgrV
C7OdUJRCh2hoFsWrwy1VgSKBIU9cKQedFHXxoAyFiRa9TqGHyoCUVVdIEAtniQ1INm0gcdGhQwce
eUeatGk7QZKGH7zoeHr37t3Jd+++93gAh90e9boQmFt/r25VLjwJaK7vrawvSeLUH+vPfdf/sNv7
bv1X3bB0w9Kx0PpdkQCg12vGOdk20UdCrURXpnln7373k1pJOOz2dMPSDTKkM5Ohs/Xk/rrV7J7O
F/JUZq/XnM1Hyg/qMwkdG/Dz5xKhJUnvV3t28nT5Bn3B48KNjQs5thcHT29mGRW3nN24efzYv2XN
E5Vd+Djy2ylSvPcYjXVvLx8iIdSGt2MVlcfaZBsDANm2leCuea0mAuD+ULvtbW/lFlbogoH7Jued
FI0xjMYxrpJXHylcowEOzNdHEqOp+sQY6+hhEcsOx8nFQlRaCCAnSL5iPrwSps/IMnMVRt2hSitH
fKuqDa853564b6KK53bILc+wPiRtjRJRXjVJUxY9x6iK5VYCgjMSkqYsGhZ1Lo1JTZNdxVS7b7oO
IrIAyLYt+8Oxi2UTPZxFRMWcq4QqKqZyALdNpKie5i3kcp9ETULi4raeW1IBAORyzuIPANRG3bHr
jl13GlANHiRcsstrMSMut+x6DOHKZq/v1HL6hMeLR2LuLfn9avsn/P1wMy9fhb4Yvl/t5aufBx99
w+6Tg71nkxMp8/mnwUcxF8WlSPFe45/jHzmvS+H5rc4Wmf+WEVSH3V5nLl8WJ2YkqWaTgIfkPG+6
3IZNGBFC/zhyyK/GyQltvX2xngJRzYW9rnN1A+hsWfMFedg9lbQwU3VGjtdf53mzO71aElgFryTQ
BF8IAABD3Dss5FfmYuwJgf4CTEzeIGc0BwBKU1HHlHqHXr/I/BnuLd5uggQ7TSdftttfHxV+uUN1
OOruDMTpARa+zxFzarpzJLDu9Hr38QTgdP6LAFG6MkeKxlStJOgaKTcKTIHkaxuAaTwxMXG9ItOG
IVCzBPQXl1TomVP5cm7SbExWI8nd4BQa4J3OXH61MO0NXPbs7HXttlLg3bVJE0+tlgTf2tKISNpX
K3OXmIfXSAyIu+cscD/c8YNH592mCgCwcOPW/gFz1+DY2p9J3+6f4kNCRnJ/qyPrboClGOsa48Pu
GpkyAndnzVFZpOryLmjJdwUAwDS86DVUqdntABV3PtCSivueHFL19suvG4KkVZwGVGNZt6tCVFTb
4nk15v3w9gQwcaaMQv3l7BYPRna6yPE+x2TgPsJtnqsbjsYAACOrGLSnpClgWMx1AwAAtZQZGP0h
ktVSxjTIYok+Ghibs/egZdcduwL3gnQmqtRsSzeY60abY2sbqV7AvZFtW6EukV137HrN7kcNDdEN
kHIAolKLnIcR9TO1KLdMR+cOfXgcr4IkiQH/PgiGdXAv9T8OPprZ+Cl7CwCe7X3prWq3lmf2Ftxr
bkKVufovDu78wG5JpfL9wuVsJ3/iCsyW04yCFP8rHP+1wcVMCyoCE4/VRr3828Mqph/dR3xANh9L
zYL1cds/vQEkq5h4NBIJriI0VjsckO1FY/NyVCQPRWVXE3wl+YBsSVvb1SZnligqnwG3iyMWJuAn
BkgG/YcYL2dp2y0UFceAIrIGqLIrWkVjLCEZMBm4apf6nD4CjAKx6b59dLQ5yPn25NIPQnazhVaE
0Xg5vN2CnWWiuHKmj1DTMrpB+MyHgbFZHCmBQza2LJFqzpLwWk2EePsLXNPAKxMOlD8nUYTXkLbr
9p2fgRC2W+Q8HIUSA2h5RGJAxDwMpouERKGK05DPscPZxIA3nve2t/3nA/gsXZNSpIjEO/7OyYGx
eRduXzML7bUIuT50tAnGhcd0pIrGV6bT3iaCe4gU8ObSutNb1lKkSIJ3c3nj02mT5IZHITpN+G0h
SY/4JOW3rnByJEzM/wDxH4usbI8jjxk+AAAAAElFTkSuQmCC

------=_NextPart_000_0071_01CDD142.CF16B130--





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 18:11:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 13:11:10 2012
Received: from localhost ([127.0.0.1]:51744 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfaU2-0005WJ-5f
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 13:11:10 -0500
Received: from mtaout20.012.net.il ([80.179.55.166]:58638)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TfaTz-0005WB-6J
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 13:11:08 -0500
Received: from conversion-daemon.a-mtaout20.012.net.il by
	a-mtaout20.012.net.il (HyperSendmail v2007.08) id
	<0MEG00I00UEGDL00@HIDDEN> for
	13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 20:08:41 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MEG00I3EVQG0S60@HIDDEN>;
	Mon, 03 Dec 2012 20:08:41 +0200 (IST)
Date: Mon, 03 Dec 2012 20:08:35 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Drew Adams <drew.adams@HIDDEN>
Message-id: <83624jrot8.fsf@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
	<562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: "Drew Adams" <drew.adams@HIDDEN> > Cc:
	<mario.giovinazzo@HIDDEN>, 
	<13011 <at> debbugs.gnu.org> > Date: Mon,
	3 Dec 2012 08:44:39 -0800 > > > So does
	anyone object to lifting this limitation,
	even though it might > > degrade
	the quality of displaying the first and the last characters in > > the
	run
	of characters that have the box face? > > It's not obvious to me what
	that
	means for users. Why don't you post before and > after images so we can
	judge? [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.166 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 13011
Cc: handa@HIDDEN, 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: "Drew Adams" <drew.adams@HIDDEN> > Cc: <mario.giovinazzo@HIDDEN>,
    <13011 <at> debbugs.gnu.org> > Date: Mon, 3 Dec 2012 08:44:39 -0800 > > > So does
    anyone object to lifting this limitation, even though it might > > degrade
    the quality of displaying the first and the last characters in > > the run
    of characters that have the box face? > > It's not obvious to me what that
    means for users. Why don't you post before and > after images so we can judge?
    [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.166 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.4998]

> From: "Drew Adams" <drew.adams@HIDDEN>
> Cc: <mario.giovinazzo@HIDDEN>, <13011 <at> debbugs.gnu.org>
> Date: Mon, 3 Dec 2012 08:44:39 -0800
> 
> > So does anyone object to lifting this limitation, even though it might
> > degrade the quality of displaying the first and the last characters in
> > the run of characters that have the box face?
> 
> It's not obvious to me what that means for users.  Why don't you post before and
> after images so we can judge?

The examples I have don't show any significant effect.  But I can
explain how you can experiment and see yourself.

Evaluate this:

  (custom-set-variables '(global-hl-line-mode t))
  (custom-set-faces '(hl-line ((t (:box (:line-width -1 :color "gray50"))))))

Then visit any files you like, and move cursor vertically.  You will
see that the text of the current line moves 1 pixel to the right when
you move cursor into that line.  This 1-pixel move is to leave enough
space for the 1-pixel border of the box on the left side of the line,
so that the first character is displayed with all its pixels visible.

The change that is being requested here is to prevent that 1-pixel
shift, which means the box border will be drawn ON the left-most
character, obscuring some of its pixels on the left.

For a more prominent effect, replace -1 above with -4.

> And what is the tradeoff for this "degrading"?  What are users gaining by this
> sacrifice?

The gain is that, with the above settings in effect, the text of a
line will not shift to the left when cursor moves into that line.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 16:47:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 11:47:09 2012
Received: from localhost ([127.0.0.1]:51670 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfZAi-0003Zb-Sz
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 11:47:09 -0500
Received: from userp1040.oracle.com ([156.151.31.81]:34824)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1TfZAg-0003ZU-Qj
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 11:47:07 -0500
Received: from ucsinet21.oracle.com (ucsinet21.oracle.com [156.151.31.93])
	by userp1040.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id qB3Gif5T013684
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Mon, 3 Dec 2012 16:44:42 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by ucsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	qB3GiemU011180
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Mon, 3 Dec 2012 16:44:41 GMT
Received: from abhmt110.oracle.com (abhmt110.oracle.com [141.146.116.62])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	qB3Giev2013740; Mon, 3 Dec 2012 10:44:40 -0600
Received: from dradamslap1 (/130.35.178.8)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Mon, 03 Dec 2012 08:44:39 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Eli Zaretskii'" <eliz@HIDDEN>, "'Kenichi Handa'" <handa@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN> <83ip8jrt7p.fsf@HIDDEN>
Subject: RE: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Date: Mon, 3 Dec 2012 08:44:39 -0800
Message-ID: <562186ED35E84B3086ABFBDAB2F056FD@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <83ip8jrt7p.fsf@HIDDEN>
Thread-Index: Ac3RdB3Nh2cDf78qS2q3GTlR8VD0EAAARsRw
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: ucsinet21.oracle.com [156.151.31.93]
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.5 (-)

> So does anyone object to lifting this limitation, even though it might
> degrade the quality of displaying the first and the last characters in
> the run of characters that have the box face?

It's not obvious to me what that means for users.  Why don't you post before and
after images so we can judge?

Or if this affects something other than the visual appearance, so images won't
show the difference, please explain what this will change for users.

And what is the tradeoff for this "degrading"?  What are users gaining by this
sacrifice?

Thx.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 16:36:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 11:36:05 2012
Received: from localhost ([127.0.0.1]:51662 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfZ01-0003KP-F1
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 11:36:05 -0500
Received: from mtaout22.012.net.il ([80.179.55.172]:48915)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TfYzy-0003KH-Ml
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 11:36:03 -0500
Received: from conversion-daemon.a-mtaout22.012.net.il by
	a-mtaout22.012.net.il (HyperSendmail v2007.08) id
	<0MEG00J00R9CX600@HIDDEN> for
	13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 18:33:35 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout22.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MEG00HO7RBYY6V0@HIDDEN>;
	Mon, 03 Dec 2012 18:33:35 +0200 (IST)
Date: Mon, 03 Dec 2012 18:33:30 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <87mwxvlc0h.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Kenichi Handa <handa@HIDDEN>
Message-id: <83ip8jrt7p.fsf@HIDDEN>
References: <87mwxvlc0h.fsf@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: Kenichi Handa <handa@HIDDEN> > Cc:
	eliz@HIDDEN, 
	mario.giovinazzo@HIDDEN, 13011 <at> debbugs.gnu.org > Date: Mon,
	03 Dec 2012
	18:29:18 +0900 > > In article <jwvhao8z0y8.fsf-monnier+emacs@HIDDEN>,
	Stefan
	Monnier <monnier@HIDDEN> writes: > > > > I made a provisional
	change
	that behaves with left and right borders > > > like it does with
	horizontal ones, and it seems to work,
	at least with > > > character display (didn't
	text with images, image slices, composite > > > characters,
	etc.). But I'd
	like to ask Handa-san (CC'ed), who wrote > > > the code for this feature
	(almost 12 years ago!),
	whether he might > > > remember why the code deliberately
	makes the left and right borders > > > behave differently from top and
	bottom
	ones. > > > I'm curious as well. The only think that comes to mind is
	that in most > > fonts,
	there's usually some empty pixel-line(s) at the top and
	the > > bottom, whereas there often't isn't any empty pixel-lines at all
	on the > > left (and/or on the right) side. So there's more risk of
	overwriting
	> > useful pixels on the left&right than at top&bottom. > > Yes. That's
	the
	reason of this asymmetry. The original > intention of this feature was
	to
	make modeline occupy only > canonical line height even with the current
	style. [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.172 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.4233]
X-Debbugs-Envelope-To: 13011
Cc: monnier@HIDDEN, mario.giovinazzo@HIDDEN,
	13011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.7 (/)

> From: Kenichi Handa <handa@HIDDEN>
> Cc: eliz@HIDDEN,  mario.giovinazzo@HIDDEN,  13011 <at> debbugs.gnu.org
> Date: Mon, 03 Dec 2012 18:29:18 +0900
> 
> In article <jwvhao8z0y8.fsf-monnier+emacs@HIDDEN>, Stefan Monnier <monnier@HIDDEN> writes:
> 
> > > I made a provisional change that behaves with left and right borders
> > > like it does with horizontal ones, and it seems to work, at least with
> > > character display (didn't text with images, image slices, composite
> > > characters, etc.).  But I'd like to ask Handa-san (CC'ed), who wrote
> > > the code for this feature (almost 12 years ago!), whether he might
> > > remember why the code deliberately makes the left and right borders
> > > behave differently from top and bottom ones.
> 
> > I'm curious as well.  The only think that comes to mind is that in most
> > fonts, there's usually some empty pixel-line(s) at the top and the
> > bottom, whereas there often't isn't any empty pixel-lines at all on the
> > left (and/or on the right) side.  So there's more risk of overwriting
> > useful pixels on the left&right than at top&bottom.
> 
> Yes.  That's the reason of this asymmetry.  The original
> intention of this feature was to make modeline occupy only
> canonical line height even with the current style.

So does anyone object to lifting this limitation, even though it might
degrade the quality of displaying the first and the last characters in
the run of characters that have the box face?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 3 Dec 2012 09:35:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 03 04:35:57 2012
Received: from localhost ([127.0.0.1]:50814 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TfSRQ-000840-UV
	for submit <at> debbugs.gnu.org; Mon, 03 Dec 2012 04:35:57 -0500
Received: from fencepost.gnu.org ([208.118.235.10]:38339)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <handa@HIDDEN>) id 1TfSRP-00083t-0k
	for 13011 <at> debbugs.gnu.org; Mon, 03 Dec 2012 04:35:55 -0500
Received: from 253.240.accsnet.ne.jp ([202.220.240.253]:61360 helo=mongkok)
	by fencepost.gnu.org with esmtpa (Exim 4.71)
	(envelope-from <handa@HIDDEN>)
	id 1TfSOb-0007JG-2L; Mon, 03 Dec 2012 04:33:31 -0500
From: Kenichi Handa <handa@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-Reply-To: <jwvhao8z0y8.fsf-monnier+emacs@HIDDEN> (message from Stefan
	Monnier on Thu, 29 Nov 2012 14:06:07 -0500)
Date: Mon, 03 Dec 2012 18:29:18 +0900
Message-ID: <87mwxvlc0h.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: 13011
Cc: eliz@HIDDEN, 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

In article <jwvhao8z0y8.fsf-monnier+emacs@HIDDEN>, Stefan Monnier <monnier@HIDDEN> writes:

> > I made a provisional change that behaves with left and right borders
> > like it does with horizontal ones, and it seems to work, at least with
> > character display (didn't text with images, image slices, composite
> > characters, etc.).  But I'd like to ask Handa-san (CC'ed), who wrote
> > the code for this feature (almost 12 years ago!), whether he might
> > remember why the code deliberately makes the left and right borders
> > behave differently from top and bottom ones.

> I'm curious as well.  The only think that comes to mind is that in most
> fonts, there's usually some empty pixel-line(s) at the top and the
> bottom, whereas there often't isn't any empty pixel-lines at all on the
> left (and/or on the right) side.  So there's more risk of overwriting
> useful pixels on the left&right than at top&bottom.

Yes.  That's the reason of this asymmetry.  The original
intention of this feature was to make modeline occupy only
canonical line height even with the current style.

---
Kenichi Handa
handa@HIDDEN





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 30 Nov 2012 08:15:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 30 03:15:53 2012
Received: from localhost ([127.0.0.1]:46142 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TeLlI-0004Hq-QB
	for submit <at> debbugs.gnu.org; Fri, 30 Nov 2012 03:15:53 -0500
Received: from mtaout20.012.net.il ([80.179.55.166]:63883)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TeLlG-0004Hg-1O
	for 13011 <at> debbugs.gnu.org; Fri, 30 Nov 2012 03:15:51 -0500
Received: from conversion-daemon.a-mtaout20.012.net.il by
	a-mtaout20.012.net.il (HyperSendmail v2007.08) id
	<0MEA00F00JSH3N00@HIDDEN> for
	13011 <at> debbugs.gnu.org; Fri, 30 Nov 2012 10:13:44 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MEA00EB0K6VSM80@HIDDEN>;
	Fri, 30 Nov 2012 10:13:44 +0200 (IST)
Date: Fri, 30 Nov 2012 10:13:30 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <13b4ec68081.mario.giovinazzo@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: "mario.giovinazzo@HIDDEN" <mario.giovinazzo@HIDDEN>
Message-id: <83ip8nv785.fsf@HIDDEN>
References: <13b4ec68081.mario.giovinazzo@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: [Please don't remove the bug address from the CC list,
	we
	want all this discussion to be archived in the bug tracker.] > Date:
	Fri, 
	30 Nov 2012 01:45:30 +0100 (CET) > From: "mario.giovinazzo@HIDDEN"
	<mario.giovinazzo@HIDDEN>
	> Cc: <monnier@HIDDEN> > > The horizontal flickering has 2
	cases:
	> > 1) font-lock mode disabled. > Current line has a single global box
	around
	current line > Moving cursor vertically produce 1 pixel flickering due
	to
	the left border > that adds 1 pixel. > Moving cursor horizontal (along
	the
	same line) produce flickering crossing > parenthesis when paren-mode is
	enabled.
	2 more pixels if the matching > one is in another line, 4 more pixels if
	on the same. This because it draw > a box on highlight parenthesis
	adding 2 pixels for box. [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.166 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 13011
Cc: monnier@HIDDEN, 13011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  [Please don't remove the bug address from the CC list, we
   want all this discussion to be archived in the bug tracker.] > Date: Fri,
   30 Nov 2012 01:45:30 +0100 (CET) > From: "mario.giovinazzo@HIDDEN" <mario.giovinazzo@HIDDEN>
    > Cc: <monnier@HIDDEN> > > The horizontal flickering has 2 cases:
    > > 1) font-lock mode disabled. > Current line has a single global box around
    current line > Moving cursor vertically produce 1 pixel flickering due to
    the left border > that adds 1 pixel. > Moving cursor horizontal (along the
    same line) produce flickering crossing > parenthesis when paren-mode is enabled.
    2 more pixels if the matching > one is in another line, 4 more pixels if
   on the same. This because it draw > a box on highlight parenthesis adding
   2 pixels for box. [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.166 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.4999]


[Please don't remove the bug address from the CC list, we want all
this discussion to be archived in the bug tracker.]

> Date: Fri, 30 Nov 2012 01:45:30 +0100 (CET)
> From: "mario.giovinazzo@HIDDEN" <mario.giovinazzo@HIDDEN>
> Cc:  <monnier@HIDDEN>
> 
> The horizontal flickering has 2 cases:
> 
> 1) font-lock mode disabled.
> Current line has a single global box around current line 
> Moving cursor vertically produce 1 pixel flickering due to the left border 
> that adds 1 pixel.
> Moving cursor horizontal (along the same line) produce flickering crossing 
> parenthesis when paren-mode is enabled. 2 more pixels if the matching 
> one is in another line, 4 more pixels if on the same. This because it draw 
> a box on highlight parenthesis adding  2 pixels for box.

This is the same problem as with stretches of white space.  Its reason
is separate from the one that causes the entire line to shift one
pixel to the right when the line thickness is -1.

> 2) Font-lock-mode enabled.
> Current line seems to have a single global box but looking careful it has 
> many consecutive boxes, one for every font-lock-face.

Same as above: a different reason.

> Moving cursor vertical increase current line length of one pixel for box 
> (cab be very big) producing flickering.

This is done deliberately, as I show in the code snippets I posted.
We are discussing why was this done, and will see whether and how to
fix that after we understand the reason(s).

> This happens also in line without space and tab like this no sense line:
> void{(if(a<b)while(c=d)do)switch(e)

Same as above: a different reason.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 29 Nov 2012 19:08:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 29 14:08:11 2012
Received: from localhost ([127.0.0.1]:45543 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Te9T1-00006f-1R
	for submit <at> debbugs.gnu.org; Thu, 29 Nov 2012 14:08:11 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:1143)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1Te9Sz-00006Y-L5
	for 13011 <at> debbugs.gnu.org; Thu, 29 Nov 2012 14:08:09 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAG6Zu09FxKh9/2dsb2JhbABEtBGBCIIVAQEEAVYjBQsLNBIUGA0kiBwFugmQRAOIQppxgViDBw
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="208764955"
Received: from 69-196-168-125.dsl.teksavvy.com (HELO ceviche.home)
	([69.196.168.125])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	29 Nov 2012 14:06:08 -0500
Received: by ceviche.home (Postfix, from userid 20848)
	id C776766127; Thu, 29 Nov 2012 14:06:07 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Message-ID: <jwvhao8z0y8.fsf-monnier+emacs@HIDDEN>
References: <793025287.20121127114224@HIDDEN> <838v9nx7q1.fsf@HIDDEN>
	<1205106717.20121128161453@HIDDEN> <83a9u1wr3k.fsf@HIDDEN>
	<jwvzk213u19.fsf-monnier+emacs@HIDDEN> <83vccouzqw.fsf@HIDDEN>
Date: Thu, 29 Nov 2012 14:06:07 -0500
In-Reply-To: <83vccouzqw.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 29 Nov
	2012 18:42:47 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13011
Cc: Kenichi Handa <handa@HIDDEN>, 13011 <at> debbugs.gnu.org,
	mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

>      area.  The vertical (left and right) borders of the box are drawn
>      in the same way as when this value is positive.  */
>   int box_line_width;
[...]
> I made a provisional change that behaves with left and right borders
> like it does with horizontal ones, and it seems to work, at least with
> character display (didn't text with images, image slices, composite
> characters, etc.).  But I'd like to ask Handa-san (CC'ed), who wrote
> the code for this feature (almost 12 years ago!), whether he might
> remember why the code deliberately makes the left and right borders
> behave differently from top and bottom ones.

I'm curious as well.  The only think that comes to mind is that in most
fonts, there's usually some empty pixel-line(s) at the top and the
bottom, whereas there often't isn't any empty pixel-lines at all on the
left (and/or on the right) side.  So there's more risk of overwriting
useful pixels on the left&right than at top&bottom.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 29 Nov 2012 16:44:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 29 11:44:33 2012
Received: from localhost ([127.0.0.1]:45398 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Te7E1-0004E6-CA
	for submit <at> debbugs.gnu.org; Thu, 29 Nov 2012 11:44:33 -0500
Received: from mtaout20.012.net.il ([80.179.55.166]:64773)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1Te7Dx-0004Du-K2
	for 13011 <at> debbugs.gnu.org; Thu, 29 Nov 2012 11:44:32 -0500
Received: from conversion-daemon.a-mtaout20.012.net.il by
	a-mtaout20.012.net.il (HyperSendmail v2007.08) id
	<0ME900600CZ1V100@HIDDEN> for
	13011 <at> debbugs.gnu.org; Thu, 29 Nov 2012 18:42:27 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0ME90061XD2Q57G0@HIDDEN>;
	Thu, 29 Nov 2012 18:42:26 +0200 (IST)
Date: Thu, 29 Nov 2012 18:42:47 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <jwvzk213u19.fsf-monnier+emacs@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stefan Monnier <monnier@HIDDEN>, Kenichi Handa <handa@HIDDEN>
Message-id: <83vccouzqw.fsf@HIDDEN>
References: <793025287.20121127114224@HIDDEN> <838v9nx7q1.fsf@HIDDEN>
	<1205106717.20121128161453@HIDDEN> <83a9u1wr3k.fsf@HIDDEN>
	<jwvzk213u19.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: Stefan Monnier <monnier@HIDDEN> >
	Cc: mario
	giovinazzo <mario.giovinazzo@HIDDEN>, 13011 <at> debbugs.gnu.org > Date:
	Wed, 28 Nov 2012 23:39:04 -0500 > > When the box width is 1, indeed,
	there's no much Emacs could do,
	but > when the width is -1 (i.e. drawn "inside" the
	normal text box), > characters shouldn't move, whereas they do (they get
	shifted > horizontally by a few pixels,
	and if you try it in the *Help* buffer
	> you may see that the number of pixel shifts seems to increase at >
	transition points between different fonts,
	such as italics for function > arguments). [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.166 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org, mario.giovinazzo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: Stefan Monnier <monnier@HIDDEN> > Cc: mario
    giovinazzo <mario.giovinazzo@HIDDEN>, 13011 <at> debbugs.gnu.org > Date:
   Wed, 28 Nov 2012 23:39:04 -0500 > > When the box width is 1, indeed, there's
    no much Emacs could do, but > when the width is -1 (i.e. drawn "inside" the
    normal text box), > characters shouldn't move, whereas they do (they get
   shifted > horizontally by a few pixels, and if you try it in the *Help* buffer
    > you may see that the number of pixel shifts seems to increase at > transition
    points between different fonts, such as italics for function > arguments).
    [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.166 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.4922]

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: mario giovinazzo <mario.giovinazzo@HIDDEN>,  13011 <at> debbugs.gnu.org
> Date: Wed, 28 Nov 2012 23:39:04 -0500
> 
> When the box width is 1, indeed, there's no much Emacs could do, but
> when the width is -1 (i.e. drawn "inside" the normal text box),
> characters shouldn't move, whereas they do (they get shifted
> horizontally by a few pixels, and if you try it in the *Help* buffer
> you may see that the number of pixel shifts seems to increase at
> transition points between different fonts, such as italics for function
> arguments).

Looks like this was done on (some) purpose:

In xdisp.c:

	  /* If face has a box, add the box thickness to the character
	     height.  If character has a box line to the left and/or
	     right, add the box line width to the character's width.  */
	  if (face->box != FACE_NO_BOX)
	    {
	      int thick = face->box_line_width;

	      if (thick > 0)
		{
		  it->ascent += thick;
		  it->descent += thick;
		}
	      else
		thick = -thick;   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

	      if (it->start_of_box_run_p)
		it->pixel_width += thick;  <<<<<<<<<<<<<<<<<<<<<<<<<
	      if (it->end_of_box_run_p)
		it->pixel_width += thick;
	    }

Note that the ascent and descent are only enlarged when the value is
positive, but pixel_width is also enlarged when the value is negative.

And then in xterm.c:

  /* If first glyph of S has a left box line, start drawing the text
     of S to the right of that box line.  */
  if (s->face->box != FACE_NO_BOX
      && s->first_glyph->left_box_line_p)
    x = s->x + eabs (s->face->box_line_width);  <<<<<<<<<<<<<<<<<<<<
  else         ^^^^
    x = s->x;

Moreover, the commentary in dispextern.h explicitly says that the
left/right borders are not affected by the sign of the box width (note
the last sentence):

  /* Non-zero means characters in this face have a box of that
     thickness around them.  If this value is negative, its absolute
     value indicates the thickness, and the horizontal (top and
     bottom) borders of box are drawn inside of the character glyphs'
     area.  The vertical (left and right) borders of the box are drawn
     in the same way as when this value is positive.  */
  int box_line_width;

and the doc string in faces.el only mentions the top and bottom borders
of the box as being affected by negative values:

  `:box'

  VALUE specifies whether characters in FACE should have a box drawn
  around them.  If VALUE is nil, explicitly don't draw boxes.  If
  VALUE is t, draw a box with lines of width 1 in the foreground color
  of the face.  If VALUE is a string, the string must be a color name,
  and the box is drawn in that color with a line width of 1.  Otherwise,
  VALUE must be a property list of the form `(:line-width WIDTH
  :color COLOR :style STYLE)'.  If a keyword/value pair is missing from
  the property list, a default value will be used for the value, as
  specified below.  WIDTH specifies the width of the lines to draw; it
  defaults to 1.  If WIDTH is negative, the absolute value is the width
  of the lines, and draw top/bottom lines inside the characters area,
  not around it.

Only the ELisp manual makes it sound like both horizontal and vertical
borders are drawn inside the character cell:

    `(:line-width WIDTH :color COLOR :style STYLE)'
          This way you can explicitly specify all aspects of the box.
          The value WIDTH specifies the width of the lines to draw; it
          defaults to 1.  A negative width -N means to draw a line of
          width N that occupies the space of the underlying text, thus
          avoiding any increase in the character height or width.

I made a provisional change that behaves with left and right borders
like it does with horizontal ones, and it seems to work, at least with
character display (didn't text with images, image slices, composite
characters, etc.).  But I'd like to ask Handa-san (CC'ed), who wrote
the code for this feature (almost 12 years ago!), whether he might
remember why the code deliberately makes the left and right borders
behave differently from top and bottom ones.

To see the original changeset that introduced this feature, type

   bzr diff -r 36005..36010




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 29 Nov 2012 04:41:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 28 23:41:05 2012
Received: from localhost ([127.0.0.1]:44427 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tdvvs-0003Ry-Vj
	for submit <at> debbugs.gnu.org; Wed, 28 Nov 2012 23:41:05 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:12870)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1Tdvvr-0003Rr-3z
	for 13011 <at> debbugs.gnu.org; Wed, 28 Nov 2012 23:41:03 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAG6Zu09FxKh9/2dsb2JhbABEtBGBCIIVAQEEAVYjBQsLNBIUGA0kiBwFugmQRAOIQppxgViDBw
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="208722893"
Received: from 69-196-168-125.dsl.teksavvy.com (HELO pastel.home)
	([69.196.168.125])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	28 Nov 2012 23:39:04 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 7922458B5B; Wed, 28 Nov 2012 23:39:04 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
Message-ID: <jwvzk213u19.fsf-monnier+emacs@HIDDEN>
References: <793025287.20121127114224@HIDDEN> <838v9nx7q1.fsf@HIDDEN>
	<1205106717.20121128161453@HIDDEN> <83a9u1wr3k.fsf@HIDDEN>
Date: Wed, 28 Nov 2012 23:39:04 -0500
In-Reply-To: <83a9u1wr3k.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 28 Nov
	2012 19:54:23 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org, mario giovinazzo <mario.giovinazzo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

>> (custom-set-variables '(global-hl-line-mode t))
>> (custom-set-faces '(hl-line ((t (:box (:line-width 1 :color "gray50"))))))
> Thanks.

Actually the interesting case is when the box is of width -1.

> I see no flickering when moving cursor horizontally within the same
> screen line.  None at all.

The problem is when moving vertically.

> If the above is what you see, then please tell what you expect Emacs
> to do instead.

When the box width is 1, indeed, there's no much Emacs could do, but
when the width is -1 (i.e. drawn "inside" the normal text box),
characters shouldn't move, whereas they do (they get shifted
horizontally by a few pixels, and if you try it in the *Help* buffer
you may see that the number of pixel shifts seems to increase at
transition points between different fonts, such as italics for function
arguments).


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 28 Nov 2012 17:57:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 28 12:57:46 2012
Received: from localhost ([127.0.0.1]:43958 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TdltJ-00031S-GT
	for submit <at> debbugs.gnu.org; Wed, 28 Nov 2012 12:57:46 -0500
Received: from mtaout21.012.net.il ([80.179.55.169]:39134)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TdltF-00031H-7D
	for 13011 <at> debbugs.gnu.org; Wed, 28 Nov 2012 12:57:44 -0500
Received: from conversion-daemon.a-mtaout21.012.net.il by
	a-mtaout21.012.net.il (HyperSendmail v2007.08) id
	<0ME700600LM9SZ00@HIDDEN> for
	13011 <at> debbugs.gnu.org; Wed, 28 Nov 2012 19:54:05 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout21.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0ME7006K4LQ5OE40@HIDDEN>;
	Wed, 28 Nov 2012 19:54:05 +0200 (IST)
Date: Wed, 28 Nov 2012 19:54:23 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <1205106717.20121128161453@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: mario giovinazzo <mario.giovinazzo@HIDDEN>
Message-id: <83a9u1wr3k.fsf@HIDDEN>
References: <793025287.20121127114224@HIDDEN> <838v9nx7q1.fsf@HIDDEN>
	<1205106717.20121128161453@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: [Please keep the bug address on the CC list.] > Date:
	Wed, 28 Nov 2012 16:14:53 +0100 > From: mario giovinazzo
	<mario.giovinazzo@HIDDEN>
	> > To reproduce the behavior is very easy. > My .emacs file contains
	only
	this 2 lines: > > > (custom-set-variables '(global-hl-line-mode t)) >
	(custom-set-faces
	'(hl-line ((t (:box (:line-width 1 :color "gray50")))))) [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.169 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  [Please keep the bug address on the CC list.] > Date: Wed,
    28 Nov 2012 16:14:53 +0100 > From: mario giovinazzo <mario.giovinazzo@HIDDEN>
    > > To reproduce the behavior is very easy. > My .emacs file contains only
    this 2 lines: > > > (custom-set-variables '(global-hl-line-mode t)) > (custom-set-faces
    '(hl-line ((t (:box (:line-width 1 :color "gray50")))))) [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.169 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]

[Please keep the bug address on the CC list.]

> Date: Wed, 28 Nov 2012 16:14:53 +0100
> From: mario giovinazzo <mario.giovinazzo@HIDDEN>
> 
> To reproduce the behavior is very easy.
> My .emacs file contains only this 2  lines:
> 
> 
> (custom-set-variables '(global-hl-line-mode t))
> (custom-set-faces '(hl-line ((t (:box (:line-width 1 :color "gray50"))))))

Thanks.

> If you open any text file and move the cursor inside text with arrow key
> (up, down, right, left), the" box around text" follow the cursor,
> and the text flickers (I suppose +- 2 pixels). It is evident.

I see no flickering when moving cursor horizontally within the same
screen line.  None at all.

When moving cursor vertically, I see this:

  . The text of the current line moves slightly up when the current
    line moves up or down.

  . When the current line is empty, the text in all the lines below it
    moves up slightly, then moves back down when the current lines
    becomes a line with some text.

Is this what you call "flicker"?  Or do you see something else?

If the above is what you see, then please tell what you expect Emacs
to do instead.  You've changed the face of the current line such that
it takes slightly more pixels on the screen.  Emacs just obeys your
specifications, it cannot display a line in less pixels than it needs
to draw all of the characters on it in the face you requested.  The
same would happen if you set the hl-line face to use a larger font,
for example.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at 13011 <at> debbugs.gnu.org:


Received: (at 13011) by debbugs.gnu.org; 27 Nov 2012 17:44:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 27 12:44:43 2012
Received: from localhost ([127.0.0.1]:41982 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TdPD9-00012M-0R
	for submit <at> debbugs.gnu.org; Tue, 27 Nov 2012 12:44:43 -0500
Received: from mtaout22.012.net.il ([80.179.55.172]:51775)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TdPD5-00012D-Qr
	for 13011 <at> debbugs.gnu.org; Tue, 27 Nov 2012 12:44:41 -0500
Received: from conversion-daemon.a-mtaout22.012.net.il by
	a-mtaout22.012.net.il (HyperSendmail v2007.08) id
	<0ME500M00QH12R00@HIDDEN> for
	13011 <at> debbugs.gnu.org; Tue, 27 Nov 2012 19:42:47 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout22.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0ME500LP2QJBSA60@HIDDEN>;
	Tue, 27 Nov 2012 19:42:47 +0200 (IST)
Date: Tue, 27 Nov 2012 19:43:02 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#13011: 24.2;
	Text flickering moving cursor with box around text enabled
In-reply-to: <793025287.20121127114224@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: mario giovinazzo <mario.giovinazzo@HIDDEN>
Message-id: <838v9nx7q1.fsf@HIDDEN>
References: <793025287.20121127114224@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview:  > Date: Tue,
	27 Nov 2012 11:42:24 +0100 > From: mario giovinazzo
	<mario.giovinazzo@HIDDEN> > > The problem occurs when I customize
	hl-line
	enabling box around text > to make evident the current line. > The box
	around
	text (also 1 pixel) changes the inside text position > thus producing a
	vertical
	and horizontal flickering when I move the cursor. > Setting a box of
	width
	-1 (a negative number) stops the vertical > flickering but still
	remains the horizontal one. [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.172 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 13011
Cc: 13011 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > Date: Tue, 27 Nov 2012 11:42:24 +0100 > From: mario giovinazzo
    <mario.giovinazzo@HIDDEN> > > The problem occurs when I customize hl-line
    enabling box around text > to make evident the current line. > The box around
    text (also 1 pixel) changes the inside text position > thus producing a vertical
    and horizontal flickering when I move the cursor. > Setting a box of width
    -1 (a negative number) stops the vertical > flickering but still remains
   the horizontal one. [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.172 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.4953]

> Date: Tue, 27 Nov 2012 11:42:24 +0100
> From: mario giovinazzo <mario.giovinazzo@HIDDEN>
> 
> The problem occurs when I customize hl-line enabling box around text
> to make evident the current line.
> The box around text (also 1 pixel) changes the inside text position
> thus producing a vertical and horizontal flickering when I move the cursor.
> Setting a box of width -1 (a negative number) stops the vertical
> flickering but still remains the horizontal one.

Can you please show a minimal recipe to reproduce this starting with
"emacs -Q"?  That will make the job of looking into this much easier.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Nov 2012 16:33:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 27 11:33:22 2012
Received: from localhost ([127.0.0.1]:41901 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TdO65-00060G-G8
	for submit <at> debbugs.gnu.org; Tue, 27 Nov 2012 11:33:22 -0500
Received: from eggs.gnu.org ([208.118.235.92]:57942)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <mario.giovinazzo@HIDDEN>) id 1TdIjJ-0005Nl-9H
	for submit <at> debbugs.gnu.org; Tue, 27 Nov 2012 05:49:30 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <mario.giovinazzo@HIDDEN>) id 1TdIhV-00016k-3o
	for submit <at> debbugs.gnu.org; Tue, 27 Nov 2012 05:47:41 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-6.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_HI autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:33290)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <mario.giovinazzo@HIDDEN>) id 1TdIhV-00016g-0i
	for submit <at> debbugs.gnu.org; Tue, 27 Nov 2012 05:47:37 -0500
Received: from eggs.gnu.org ([208.118.235.92]:56505)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <mario.giovinazzo@HIDDEN>) id 1TdIhT-0002Tm-VN
	for bug-gnu-emacs@HIDDEN; Tue, 27 Nov 2012 05:47:36 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <mario.giovinazzo@HIDDEN>) id 1TdIhS-00016T-I1
	for bug-gnu-emacs@HIDDEN; Tue, 27 Nov 2012 05:47:35 -0500
Received: from fep-mail-smtpout-l2e.virgilio.net ([212.48.21.155]:50676)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <mario.giovinazzo@HIDDEN>) id 1TdIhS-00016J-7J
	for bug-gnu-emacs@HIDDEN; Tue, 27 Nov 2012 05:47:34 -0500
Received: from etica-d713a111a.homenet.telecomitalia.it (79.28.244.45) by
	fep-mail-smtpout-l2e.virgilio.net (8.6.031.01) (authenticated
	as mario.giovinazzo@HIDDEN)
	id 507FD91A013DEF50 for bug-gnu-emacs@HIDDEN;
	Tue, 27 Nov 2012 11:43:28 +0100
Date: Tue, 27 Nov 2012 11:42:24 +0100
From: mario giovinazzo <mario.giovinazzo@HIDDEN>
Organization: ETICA
X-Priority: 3 (Normal)
Message-ID: <793025287.20121127114224@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 24.2; Text flickering moving cursor with box around text enabled
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Tue, 27 Nov 2012 11:33:19 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: mario giovinazzo <mario.giovinazzo@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

*** E-Mail body has been placed on clipboard, please paste it here! ***

The problem occurs when I customize hl-line enabling box around text
to make evident the current line.
The box around text (also 1 pixel) changes the inside text position
thus producing a vertical and horizontal flickering when I move the cursor.
Setting a box of width -1 (a negative number) stops the vertical
flickering but still remains the horizontal one.





In GNU Emacs 24.2.1 (i386-mingw-nt5.1.2600)
 of 2012-08-29 on MARVIN
Windowing system distributor `Microsoft Corp.', version 5.1.2600
Configured using:
 `configure --with-gcc (4.6) --cflags
 -ID:/devel/emacs/libs/libXpm-3.5.8/include
 -ID:/devel/emacs/libs/libXpm-3.5.8/src
 -ID:/devel/emacs/libs/libpng-dev_1.4.3-1/include
 -ID:/devel/emacs/libs/zlib-dev_1.2.5-2/include
 -ID:/devel/emacs/libs/giflib-4.1.4-1/include
 -ID:/devel/emacs/libs/jpeg-6b-4/include
 -ID:/devel/emacs/libs/tiff-3.8.2-1/include
 -ID:/devel/emacs/libs/gnutls-3.0.9/include'

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: ENG
  value of $XMODIFIERS: nil
  locale-coding-system: cp1252
  default enable-multibyte-characters: t

Major mode: Lisp Interaction

Minor modes in effect:
  show-paren-mode: t
  global-hl-line-mode: t
  global-hi-lock-mode: t
  hi-lock-mode: t
  cua-mode: t
  tooltip-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  size-indication-mode: t
  column-number-mode: t
  line-number-mode: t
  global-visual-line-mode: t
  visual-line-mode: t
  transient-mark-mode: t

Recent input:
<help-echo> <help-echo> <help-echo> <help-echo> <help-echo> 
<help-echo> <tool-bar> <kill-buffer> <help-echo> <help-echo> 
M-x C-y <return>

Recent messages:
Loading cua-base...done
Loading delsel...done
Loading hi-lock...done
Loading hl-line...done
Loading paren...done
For information about GNU Emacs and the GNU system, type C-h C-a.
.emacs has auto save data; consider M-x recover-this-file

Load-path shadows:
None found.

Features:
(shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 mml
easymenu mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231
mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums
mm-util mail-prsvr mail-utils time windmove cc-styles cc-align cc-engine
cc-vars cc-defs regexp-opt tempo-c-cpp tempo edmacro kmacro uniquify
advice help-fns advice-preload paren hl-line hi-lock delsel cua-base
cus-start cus-load time-date tooltip ediff-hook vc-hooks lisp-float-type
mwheel dos-w32 disp-table ls-lisp w32-win w32-vars tool-bar dnd fontset
image fringe lisp-mode register page menu-bar rfn-eshadow timer select
scroll-bar mouse jit-lock font-lock syntax facemenu font-core frame cham
georgian utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao
korean japanese hebrew greek romanian slovak czech european ethiopic
indian cyrillic chinese case-table epa-hook jka-cmpr-hook help simple
abbrev minibuffer loaddefs button faces cus-face files text-properties
overlay sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote make-network-process multi-tty emacs)





Acknowledgement sent to mario giovinazzo <mario.giovinazzo@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#13011; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 19 Jan 2018 18:30:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.